﻿#include <iostream>
#include <vector>
#include <set>
#include<map>
#include<deque>
#include <algorithm>

using namespace std;

typedef long long ll;

template<typename T> istream& operator>>(istream& in, vector<T>& a) { for (int i = 0; i < a.size(); ++i) in >> a[i]; return in; }
template<typename T> ostream& operator<<(ostream& out, vector<T>& a) { for (int i = 0; i < a.size(); ++i) out << a[i] << ' '; return out;}

template<typename T1, typename T2> istream& operator>>(istream& in, pair<T1, T2> &p){ in >> p.first >> p.second; return in; }
template<typename T1, typename T2> ostream& operator<<(ostream& out, pair<T1, T2> &p) { out << p.first << ' ' << p.second; return out; }



#define all(x) x.begin(),x.end()
#define range(i,n) for (int i=0;i<n;++i)
#define rrange(i,n) for (int i=n-1;i>=0;--i)


int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<int> a(n), b(n);
    cin >> a;
    cin >> b;

    auto ok = [&](int k, vector<int> a, vector<int> b) {
        int l = 0;
        for (int i = 0; i < n; ++i) {
            //cout << i << "\n===================\n";
            while (a[i] != 0) {
                while (( l < n && (abs(i - l) > k || b[l] == 0))) l++;
                //cout << "l = " << l << '\n';
                if (abs(i - l) > k || l == n || b[l] == 0) return false;
                int delta = min(b[l], a[i]);
                b[l] -= delta;
                a[i] -= delta;
                //cout << "a[i], b[l] = " << a[i] << ' ' << b[l] << '\n';
            }
            //cout << "===================\n";
        }
        return true;
    };

    int l = -1, r = n + 1;
    while (l + 1 < r) {
        int mid = (l + r) / 2;
        //cout << "l, r, mid = " << l << ' ' << r << ' ' << mid << '\n';
        //cout << "ok(mid) = " << ok(mid, a, b) << '\n';
        if (ok(mid, a, b))
            r = mid;
        else
            l = mid;
    }

    cout << ((r >= n) ? -1 : r);
}
