#include <algorithm>
#include <iostream>
#include <vector>
#include <numeric>
#include <bitset>
#include <iomanip>
#include <random>
#include <map>
// #include <bits/stdc++.h>

using namespace std;
#define all(o) (o).begin(), (o).end()
#define rall(o) (o).rbegin(), (o).rend()
#define len(o) (int)((o).size())
#if LOCAL
#define dbg(o) cout << #o << " = " << o << "\n";
#else
#define dbg(o)
#endif

using ll = long long;
using ld = long double;

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (const T &e : a) {
        out << e << " ";
    }
    return out;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (T &e : a) {
        in >> e;
    }
    return in;
}

mt19937_64 rnd(42);
const int MX = 2e6;
vector<int> lookup1(MX);
vector<int> lookup2(MX);

void calc_lookup() {
    for (int i = 0; i < MX; ++i) {
        lookup1[i] = rnd();
        lookup2[i] = rnd();
    }
}

// using Hash = pair<ll, ll>;
using Hash = vector<int>;
const Hash empty_set = {0, 0};

// Hash hsh(const vector<int> &v) {
//     Hash h = {0, 0};
//     for (int e : v) {
//         h.first += lookup1[e];
//         h.second += lookup2[e];
//     }
//     return h;
// }
Hash hsh(const vector<int> &v) {
    return v;
}

bool solve_rec(const vector<vector<Hash>> &hashes, const vector<int> &allowed, vector<bool> &ban_letters) {
    if (allowed.size() <= 1) return true;
    for (char c = 0; c < 26; c++) {
        if (ban_letters[c]) continue;
        bool ok = true;
        for (int i : allowed) {
            if (hashes[c][i] == empty_set) {
                ok = false;
                break;
            }
        }
        if (ok) {
            ok = true;
            ban_letters[c] = true;
            map<Hash, vector<int>> groups;
            for (int i : allowed) {
                groups[hashes[c][i]].push_back(i);
            }
            for (auto[h, g] : groups) {
                dbg(g);
                if (!solve_rec(hashes, g, ban_letters)) {
                    return false;
                }
            }
            return true;
        }
    }
    return false;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout << fixed << setprecision(16);
    calc_lookup();

    int n, m; cin >> m >> n;
    vector<string> words(n);
    cin >> words;

    vector<vector<vector<int>>> positions(26, vector<vector<int>>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            positions[words[i][j] - 'a'][i].push_back(j);
        }
    }

    // vector<vector<Hash>> hashes(26, vector<Hash>(n));
    // for (int i = 0; i < 26; ++i) {
    //     for (int j = 0; j < n; ++j) {
    //         hashes[i][j] = hsh(positions[i][j]);
    //     }
    // }

    vector<int> allowed(n);
    iota(all(allowed), 0);
    vector<bool> ban_letters(26, false);
    // if (solve_rec(hashes, allowed, ban_letters)) {
    if (solve_rec(positions, allowed, ban_letters)) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}
