#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <numeric>
#include <bitset>
#include <iomanip>
#include <random>
#include <map>
// #include <bits/stdc++.h>

using namespace std;
#define all(o) (o).begin(), (o).end()
#define rall(o) (o).rbegin(), (o).rend()
#define len(o) (int)((o).size())
#if LOCAL
#define dbg(o) cout << #o << " = " << o << "\n";
#else
#define dbg(o)
#endif

using ll = long long;
using ld = long double;

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (const T &e : a) {
        out << e << " ";
    }
    return out;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (T &e : a) {
        in >> e;
    }
    return in;
}

const int MX = 2e6;
vector<int> lookup1;
vector<int> lookup2;
using Hash = pair<ll, ll>;
Hash empty_set;

void calc_lookup() {
    empty_set = {0, 0};
    mt19937_64 rnd(42424242424);
    lookup1.assign(MX, 0);
    lookup2.assign(MX, 0);
    for (int i = 0; i < MX; ++i) {
        lookup1[i] = rnd();
        lookup2[i] = rnd();
    }
}


Hash hsh(const vector<int> &v) {
    Hash h = {0, 0};
    for (int e : v) {
        h.first += lookup1[e];
        h.second += lookup2[e];
    }
    return h;
}

bool solve_rec(const vector<vector<Hash>> &hashes, const vector<int> &allowed, vector<bool> &ban_letters) {
    if (allowed.size() <= 1) return true;
    for (int c = 0; c < 26; ++c) {
        if (ban_letters[c]) continue;
        bool ok = true;
        for (int i : allowed) {
            if (hashes[c][i] == empty_set) {
                ok = false;
                break;
            }
        }
        if (!ok) continue;

        map<Hash, vector<int>> groups;
        ban_letters[c] = true;
        for (int i : allowed) {
            groups[hashes[c][i]].push_back(i);
        }
        for (auto[h, g]: groups) {
            if (!solve_rec(hashes, g, ban_letters)) {
                return false;
            }
        }
        return true;
    }
    return false;
}

void solve() {
    int n, m;
    cin >> m >> n;
    vector<string> words(n);
    cin >> words;

    vector<vector<vector<int>>> positions(26, vector<vector<int>>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            positions[words[i][j] - 'a'][i].push_back(j);
        }
    }

    vector<vector<Hash>> hashes(26, vector<Hash>(n));
    for (int i = 0; i < 26; ++i) {
        for (int j = 0; j < n; ++j) {
            hashes[i][j] = hsh(positions[i][j]);
        }
    }

    vector<int> allowed(n);
    iota(all(allowed), 0);
    vector<bool> ban_letters(26, false);

    if (solve_rec(hashes, allowed, ban_letters)) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
    }
}


int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout << fixed << setprecision(16);

    calc_lookup();
    solve();
}
