#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define pb push_back
#define eb emplace_back
#define f first
#define s second
#define deb(a) cerr << fixed << setprecision(20) << #a << " = " << a << '\n';
#define int long long

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;

typedef tree<
    pii,
    null_type,
    less<pii>,
    rb_tree_tag,
    tree_order_statistics_node_update>
ordered_set;

const int inf = 2e9;
const ll INF = 2e18;
const int MOD1 = 1e9 + 7;
const int MOD2 = 998244353;
const int P1 = 31;
const int P2 = 37;
const int dx[4] = {0, 0, -1, 1};
const int dy[4] = {-1, 1, 0, 0};
const ld Pi = acosl(-1);
const ld EPS = 1e-11;
const int N = 2e6;
int qqq = 1;

struct item{
    int mn, mx;

    item(){
        mn = inf;
        mx = -inf;
    }

    item(int _x){
        mn = mx = _x;
    }

    item(int _mn, int _mx){
        mx = _mx;
        mn = _mn;
    }
};

struct seg_tree{
    int n;
    vector <item> t;

    seg_tree(vector <int> &a){
        n = a.size();
        t.resize(n * 4);
        build(1, 0, n - 1, a);
    }

    item comb(item a, item b){
        item ans;
        ans.mn = min(a.mn, b.mn);
        ans.mx = max(a.mx, b.mx);
        return ans;
    }

    void build(int v, int l, int r, vector <int> &a){
        if (l == r){
            t[v] = item(a[l]);
        }
        else{
            int m = (r + l) / 2;
            build(v * 2, l, m, a);
            build(v * 2 + 1, m + 1, r, a);
            t[v] = comb(t[v * 2], t[v * 2 + 1]);
        }
    }

    item get(int v, int l, int r, int l1, int r1){
        if (l > r){
            return item();
        }
        else if (l == l1 && r == r1)
            return t[v];
        else{
            int m = (r1 + l1) / 2;
            return comb(get(v * 2, l, min(r, m), l1, m), get(v * 2 + 1, max(l, m + 1), r, m + 1, r1));
        }
    }

    item get(int l, int r){
        return get(1, l, r, 0, n - 1);
    }
};

int n;

ld check(ld x, int ind, seg_tree &sg, bool f = 0){
    vector <ld> mn, mx;
    if (ind != 0)
        mn.eb(sg.get(0, ind - 1).mn);
    mn.eb(sg.get(ind, n - 1).mn * (1.0 - x));
    if (ind != 0)
        mx.eb(sg.get(0, ind - 1).mx);
    mx.eb(sg.get(ind, n - 1).mx * (1.0 - x));
    ld ans = -inf;

    for (auto i: mn){
        for (auto j: mx){
            if (f)
                cout << i << ' ' << j << '\n';
            ans = max(ans, abs(i - j));
        }
    }

    return ans;
}

void solve() {

    cin >> n;
    vector <int> a(n);

    for (int &i: a)
        cin >> i;

    seg_tree sg = seg_tree(a);

    for (int i = 0; i < n; i++){
        ld l = EPS, r = 1;
        for (int lg = 0; lg < 50; lg++){
            ld m1 = l + (r - l) / 3.0;
            ld m2 = r - (r - l) / 3.0;
            if (check(m1, i, sg) >= check(m2, i, sg))
                l = m1;
            else
                r = m2;
        }
        //cout << fixed << setprecision(20) << check(r, i, sg, 1) << '\n';
        cout << fixed << setprecision(20) << r << ' ';
    }

    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //cin >> qqq;
    while (qqq--) {
        solve();
    }
    return 0;
}
