﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <array>
#include <random>
#include <fstream>
#include <random>
using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
mt19937 rnd(228228227);
struct pt {
    ll x, y;
    pt(ll x1 = 0, ll y1 = 0) {
        x = x1;
        y = y1;
    }
    pt operator+(pt b) {
        return { x + b.x, y + b.y };
    }
    pt operator-(pt b) {
        return { x - b.x, y - b.y };
    }
    ll operator*(pt b) {
        return x * b.x + y * b.y;
    }
    ll operator%(pt b) {
        return x * b.y - y * b.x;
    }
};
istream& operator>>(istream& stream, pt& a) {
    return stream >> a.x >> a.y;
}
ostream& operator<<(ostream& stream, pt a) {
    return stream << a.x << " " << a.y << "\n";
}
ll INF = 1e18;
pt zer = { 0, 0 };
ll sqr(ll a) {
    return a * a;
}
ll sign(ll a) {
    if (a > 0) {
        return 1;
    }
    else if (a < 0) {
        return -1;
    }
    else {
        return 0;
    }
}
ll dist(pt a, pt b) {
    return sqr(a.x - b.x) + sqr(a.y - b.y);
}
vector<ll> ans;
vector<bool> used;
vector<vector<int>> g;
bool cmp(pt a, pt b) {
    if (a.x != b.x) {
        return a.x < b.x;
    }
    return a.y < b.y;
}
bool cmpangl(pair<pt, int> a, pair<pt, int> b) {
    if (a.first % b.first == 0) {
        return dist(zer, a.first) < dist(zer, b.first);
    }
    return a.first % b.first > 0;
}
void dfs(int u) {
    ans.push_back(u);
    used[u] = true;
    for (auto c : g[u]) {
        if (!used[c]) {
            dfs(c);
        }
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<pair<pt, int>> v(n), o, o1;
    g.resize(n);
    used.resize(n, false);
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    pt q = { INF, INF };
    for (int i = 0; i < n; i++) {
        cin >> v[i].first;
        v[i].second = i;
        pair<ll, ll> now = { v[i].first.x, v[i].first.y };
        if (q.y > v[i].first.y) {
            q = v[i].first;
        }
        else if (q.y == v[i].first.y && q.x > v[i].first.x) {
            q = v[i].first;
        }
    }
    for (int i = 0; i < n; i++) {
        v[i].first = v[i].first - q;
    }
    sort(all(v), cmpangl);
    for (int i = 0; i < n; i++) {
        v[i].first = v[i].first + q;
    }
    o.push_back(v[0]);
    o.push_back(v[1]);

    for (int i = 2; i < n; i++) {
        pt a = o[o.size() - 1].first, b = o[o.size() - 2].first;
        while ((a - b) % (v[i].first - a) <= 0) {
            o.pop_back();
            if (o.size() < 2) {
                break;
            }
            a = o[o.size() - 1].first, b = o[o.size() - 2].first;
        }
        o.push_back(v[i]);
    }
    bool f = true;
    vector<int> e(n);
    for (int i = 0; i < n && f; i++) {
        f = true;
        ans.clear();
        dfs(i);
       for (int i = 0; i < n; i++) {
            e[ans[i]] = v[i].second;
        }
        for (int j = 0; j < n; j++) {
            for (auto c : g[j]) {
                if (check(e[j], e[c])) {
                    f = false;
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        cout << e[i] + 1 << " ";
    }
}