#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.2,avx,avx2,tune=native")

#include <bits/stdc++.h>
#include <bits/extc++.h>

#define int long long

using namespace std;
using namespace __gnu_pbds;

#define all(x) begin(x), end(x)
#define sz(x) int(size(x))
#define rep(i, a, b) for (ll (i) = (a); (i) < (b); ++(i))
#define pb push_back

typedef vector<int> vi;
typedef pair<int, int> pii;
typedef long long ll;
typedef long double db;

template<class T>
using Tree = tree<T, null_type, less<T>, rb_tree_tag,
        tree_order_statistics_node_update>;

void fastio() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
}

//#define STRESS

constexpr db eps = 1e-9;
mt19937 rng(11);

array<ll, 4> t0{}, tp = {0, 1, 2, 3};

void input() {
    cin >> t0[0] >> t0[1] >> t0[2] >> t0[3];
}

void gen() {
    for (int i = 0; i < 4; ++i) {
        t0[i] = rng() % 2 + 1;
    }
}

double start = clock();
double getTime() {
    return (clock() - start) / CLOCKS_PER_SEC;
}

auto solve1() {
    auto recover = [&](const array<ll,4>& t, db ans) -> vector<db> {
        for (db a = 1; a < t[0] || abs(a - t[0]) < eps; a += 0.1l) {
            for (db b = 1; b <= t[1] || abs(b - t[1]) < eps; b += 0.1l) {
                db c, d;
                if (abs(b - 1) < eps)
                    c = t[2];
                else
                    c = ((ans - b) * (a - 1) - a * (a - b)) / (a * b - 1);

                if (abs(a - 1) < eps)
                    d = t[3];
                else
                    d = (b * c + a - b - c) / (a - 1);

                if (c >= 1 && d >= 1 && c <= t[2]
                    && d <= t[3] && a * d + b + c >= ans) {
                    return {db(a), db(b), c, d};
                }
            }
        }
        return {};
    };

    db ans = 3;
    array<ll, 4> ansp = {0, 1, 2, 3};
    db TL = 0.8;
    do {
        array<ll, 4> t{};
        rep(i, 0, 4) t[i] = t0[tp[i]];
        db l = 3, r = 1e9;
        while (getTime() < TL) {
            db m = (r + l) / 2;
            if (!recover(t, m).empty()) l = m;
            else r = m;
        }

        if (ans < l) {
            ans = l;
            ansp = tp;
        }
    } while (next_permutation(all(tp)));

    array<ll, 4> t{};
    rep(i, 0, 4) t[i] = t0[ansp[i]];

    recover(array<int, 4>{1,2, 6, 7}, 14.8);

#ifndef STRESS
    for (auto en: ansp) cout << en + 1 << ' ';
    cout << '\n';
    for (auto en: recover(t, ans)) cout << fixed << setprecision(15) << en << ' ';
#else
    return ans;
#endif
}

auto solve2() {
    auto t = t0;
    db step = 1e-2;
    db ans = 3;
    do {
        for (db a = 1; a <= t[0]; a += step) {
            for (db b = 1; b <= t[1]; b += step) {
                for (db c = 1; c <= t[2]; c += step) {
                    db d;
                    if (a == 1) d = t[3];
                    else d = (b * c + a - b - c) / (a - 1);

                    if (d >= 1 && d <= t[3] && abs(a * d + b + c - (b * c + a + d)) < eps) {
                        ans = max(ans, a * d + b + c);
                    }
                }
            }
        }
    } while (next_permutation(all(t)));
    return ans;
}

#ifdef STRESS
auto stress() {
    int  test = 0;
    while (1) {
        gen();
        if (solve1() < solve2() && abs(solve2() - solve1()) > eps) {
            for (auto en: t0) cout << en << ' ';
            cout << '\n';
            cout << solve2() << ' ' << solve1() << '\n';
            return;
        }
        cout << "PASSED " << ++test << '\n';
    }
}
#endif

signed main() {
#ifndef STRESS
    fastio();
    input();

    solve1();
    solve2();
#else
    stress();
#endif
}