#include <iostream>
#include <random>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <numeric>
#include <chrono>
#include <cassert>
#include <cmath>
#include <iomanip>

using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define int long long
using ll = long long;
using ld = long double;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int INF = 2e9;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> pref_mx(n + 1), suf_mx(n + 1), pref_mn(n + 1), suf_mn(n + 1);
    pref_mx[0] = 0, pref_mn[0] = INF;
    for (int i = 0; i < n; ++i) {
        pref_mx[i + 1] = max(pref_mx[i], a[i]);
        pref_mn[i + 1] = min(pref_mn[i], a[i]);
    }

    suf_mx[n] = 0, suf_mn[n] = INF;
    for (int i = n - 1; i >= 0; --i) {
        suf_mx[i] = max(suf_mx[i + 1], a[i]);
        suf_mn[i] = min(suf_mn[i + 1], a[i]);
    }

    for (int k = 0; k < n; ++k) {
        ld t1 = pref_mx[k] / (ld)suf_mx[k], t2 = pref_mn[k] / (ld)suf_mn[k];
        ld ans = INF, x;
        {
            ld val = max((ld)pref_mx[k], suf_mx[k] * (ld)1) - min((ld)pref_mn[k], suf_mn[k] * (ld)1);
            if (val < ans) {
                ans = val;
                x = 1;
            }
        }
        {
            ld val = max((ld)pref_mx[k], suf_mx[k] * (ld)0) - min((ld)pref_mn[k], suf_mn[k] * (ld)0);
            if (val < ans) {
                ans = val;
                x = 0;
            }
        }
        if (t1 <= 1) {
            ld val = max((ld)pref_mx[k], suf_mx[k] * (ld)t1) - min((ld)pref_mn[k], suf_mn[k] * (ld)t1);
            if (val < ans) {
                ans = val;
                x = t1;
            }
        }
        if (t2 <= 1) {
            ld val = max((ld)pref_mx[k], suf_mx[k] * (ld)t2) - min((ld)pref_mn[k], suf_mn[k] * (ld)t2);
            if (val < ans) {
                ans = val;
                x = t2;
            }
        }
        cout << 1 - x << ' ';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(6);
    solve();
//    int t; cin >> t; while(t--) solve();
}
