#include <iostream>
#include <random>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <numeric>
#include <chrono>
#include <cassert>
#include <cmath>

using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define int long long
using ll = long long;
using ld = long double;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int P1 = 667, MOD1 = 1e9 + 7;
const int P2 = 229, MOD2 = 998244353;

int l;
bool check(vector<string> a, int mask) {
    if (a.size() == 1) return true;
    for (int let = 0; let < 26; let++) {
        if (mask & (1 << let)) continue;
        bool good = true;
        for (auto &i : a) {
            good &= count(all(i), 'a' + let) > 0;
        }
        if (!good) continue;

        std::vector<pair<pair<ll, ll>, int>> hashes;
        for (int i = 0; i < a.size(); i++) {
            ll hash1 = 0;
            ll hash2 = 0;
            int occ = 0;
            for (int j = 0; j < l; j++) {
                if (a[i][j] == 'a' + let) {
                    hash1 = (hash1 * P1 + j) % MOD1;
                    hash2 = (hash2 * P2 + j) % MOD2;
                    occ++;
                }
            }
            hash1 *= occ, hash2 *= occ;
            hashes.emplace_back(make_pair(hash1, hash2), i);
        }
        sort(all(hashes));

        vector<int> indices = {hashes[0].second};
        for (int j = 1; j < hashes.size() && good; j++) {
            if (hashes[j].first == hashes[j - 1].first) {
                indices.push_back(hashes[j].second);
            } else {
                vector<string> a1;
                for (auto &k : indices) {
                    a1.push_back(a[k]);
                }
                good &= check(a1, mask | (1 << let));
                indices = {hashes[j].second};
            }
        }

        vector<string> a1;
        for (auto &k : indices) {
            a1.push_back(a[k]);
        }
        good &= check(a1, mask | (1 << let));

        return good;
    }
    return false;
}

void solve() {
    int n;
    std::cin >> l >> n;
    vector<string> a(n);
    for (auto &i : a) std::cin >> i;
    std::cout << (check(a, 0) ? "YES\n" : "NO\n");
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
//    int t; cin >> t; while(t--) solve();
}
