#include <vector>
#include <iostream>
#include <algorithm>
#include <iomanip>

using namespace std;

const int MAXN = 1'000'000;
const int K = 26;
const int KK = 20;

int go[MAXN][K];
int super_go[MAXN][K];
int bin_up[MAXN][KK];
int sum[MAXN];
int depth[MAXN];
int sum_less[MAXN];
int sum_kek[MAXN];
int kek[MAXN];
int trie_sz = 0;

int node() {
    fill(go[trie_sz], go[trie_sz] + K, -1);
    ++trie_sz;
    return trie_sz - 1;
}

void dfs1(int v) {
    kek[v] = sum[v];
    for (int i = 0; i < K; ++i) {
        if (go[v][i] != -1) {
            sum_kek[go[v][i]] = sum_kek[v] + kek[v];
            dfs1(go[v][i]);
            super_go[v][i] = super_go[go[v][i]][i];
            sum[v] += sum[go[v][i]];
        } else {
            super_go[v][i] = v;
        }
    }
}

void dfs2(int v) {
    int cur = sum_less[v];
    for (int i = 0; i < K; ++i) {
        if (go[v][i] != -1) {
            sum_less[go[v][i]] = cur;
            dfs2(go[v][i]);
            cur += sum[go[v][i]];
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    node();
    int n, q;
    cin >> n >> q;
    string s;
    cin >> s;
    int m = s.size();
    while (n--) {
        string t;
        cin >> t;
        int cur = 0;
        for (char c : t) {
            if (go[cur][c - 'a'] == -1) {
                go[cur][c - 'a'] = node();
                depth[go[cur][c - 'a']] = depth[cur] + 1;
                bin_up[go[cur][c - 'a']][0] = cur;
            }
            cur = go[cur][c - 'a'];
        }
        ++sum[cur];
    }
    for (int j = 1; j < KK; ++j) {
        for (int i = 0; i < trie_sz; ++i)
            bin_up[i][j] = bin_up[bin_up[i][j - 1]][j - 1];
    }
    dfs1(0);
    dfs2(0);
    vector<pair<int, char>> stack;
    vector<int> nodes;
    nodes.emplace_back(0);
    int cur_node = 0;
    for (int i = 0; i < (int) s.size(); ++i) {
        char c = s[i];
        if (cur_node != -1)
            cur_node = go[cur_node][c - 'a'];
        if (stack.empty() || c != stack.back().second) {
            stack.emplace_back(i, c);
            nodes.emplace_back(cur_node);
        } else {
            nodes.back() = cur_node;
        }
    }
    cur_node = 0;
    int cur_i = 0;
    while (cur_i < (int) s.size() && go[cur_node][s[cur_i] - 'a'] != -1) {
        cur_node = go[cur_node][s[cur_i] - 'a'];
        ++cur_i;
    }
    int ans = sum_less[cur_node] + sum_kek[cur_node];
    if (cur_i < m) {
        for (int j = 0; char('a' + j) < s[cur_i]; ++j) {
            if (go[cur_node][j] != -1)
                ans += sum[go[cur_node][j]];
        }
    }
    cout << ans << '\n';
    while (q--) {
        int k;
        char c;
        cin >> k >> c;
        --k;
        int pr = n;
        while (stack.back().first >= k) {
            pr = stack.back().first;
            stack.pop_back();
            nodes.pop_back();
        }
        if (nodes.back() != -1) {
            int ln = pr - k;
            for (int j = KK - 1; j >= 0; --j) {
                if (ln >= (1 << j)) {
                    nodes.back() = bin_up[nodes.back()][j];
                    ln -= (1 << j);
                }
            }
            cur_node = nodes.back();
            cur_i = k;
        }
        if (cur_i >= k) {
            int ln = cur_i - k;
            for (int j = KK - 1; j >= 0; --j) {
                if (ln >= (1 << j)) {
                    cur_node = bin_up[cur_node][j];
                    ln -= (1 << j);
                }
            }
            cur_node = super_go[cur_node][c - 'a'];
            ln = max(0, depth[cur_node] - m);
            for (int j = KK - 1; j >= 0; --j) {
                if (ln >= (1 << j)) {
                    cur_node = bin_up[cur_node][j];
                    ln -= (1 << j);
                }
            }
            cur_i = depth[cur_node];
        }
        stack.emplace_back(k, c);
        nodes.emplace_back(depth[cur_node] == n ? cur_node : -1);
        ans = sum_less[cur_node] + sum_kek[cur_node];
        if (cur_i < m) {
            ans += kek[cur_node];
            auto tmp = *(--lower_bound(stack.begin(), stack.end(), make_pair(cur_i + 1, 'a')));
            for (int j = 0; char('a' + j) < tmp.second; ++j) {
                if (go[cur_node][j] != -1)
                    ans += sum[go[cur_node][j]];
            }
        }
        cout << ans << '\n';
    }
    return 0;
}