#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = long double;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

// #pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

inline void prepare() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

struct Eq {
    ld a, b, c;
};

inline void solve() {
    int n;
    cin >> n;

    vector<Eq> pos, neg;

    for (int i = 0; i < n; i++) {
        Eq eq;
        cin >> eq.a >> eq.b >> eq.c;

        if (eq.a > 0) {
            pos.push_back(eq);
        } else {
            neg.push_back(eq);
        }
    }

    vector<ld> posValsX, negValsX;

    for (auto eq: pos) {
        ld val = - (eq.b * eq.b / (4.0l * eq.a)) + eq.c;
        posValsX.push_back(val);
    }

    for (auto eq: neg) {
        ld val = -(eq.b * eq.b / (4.0l * eq.a)) + eq.c;
        negValsX.push_back(val);
    }

    ld leftX = (posValsX.empty()) ? -1e9l : posValsX[0];

    for (auto val: posValsX) {
        if (val > leftX) {
            leftX = val;
        }
    }

    ld rightX = (negValsX.empty()) ? 1e9l : negValsX[0];

    for (auto val: negValsX) {
        if (val < rightX) {
            rightX = val;
        }
    }

    vector<ld> leftValsY, rightValsY;

    for (auto eq: pos) {
        {
            ld d = sqrtl(eq.b * eq.b - 4.0l * eq.a * (eq.c - leftX));
            ld x1 = (-eq.b - d) / (2.0l * eq.a);
            ld x2 = (-eq.b + d) / (2.0l * eq.a);

            rightValsY.push_back(x1);
            leftValsY.push_back(x2);
        }

        {
            ld d = sqrtl(eq.b * eq.b - 4.0l * eq.a * (eq.c - rightX));
            ld x1 = (-eq.b - d) / (2.0l * eq.a);
            ld x2 = (-eq.b + d) / (2.0l * eq.a);

            rightValsY.push_back(x1);
            leftValsY.push_back(x2);
        }
    }

    for (auto eq: neg) {
        {
            ld d = sqrtl(eq.b * eq.b - 4.0l * eq.a * (eq.c - leftX));
            ld x1 = (-eq.b - d) / (2.0l * eq.a);
            ld x2 = (-eq.b + d) / (2.0l * eq.a);

            rightValsY.push_back(x2);
            leftValsY.push_back(x1);
        }

        {
            ld d = sqrtl(eq.b * eq.b - 4.0l * eq.a * (eq.c - rightX));
            ld x1 = (-eq.b - d) / (2.0l * eq.a);
            ld x2 = (-eq.b + d) / (2.0l * eq.a);

            rightValsY.push_back(x2);
            leftValsY.push_back(x1);
        }
    }

    ld leftY = (rightValsY.empty()) ? -1e9l : rightValsY[0];

    for (auto val: rightValsY) {
        if (val > leftY) {
            leftY = val;
        }
    }

    ld rightY = (leftValsY.empty()) ? 1e9l : leftValsY[0];

    for (auto val: leftValsY) {
        if (val < rightY) {
            rightY = val;
        }
    }

    ld xAns = (leftX + rightX) / 2;
    ld yAns = (leftY + rightY) / 2;

    swap(xAns, yAns);

    cout << setprecision(18);
    cout << fixed;
    cout << xAns << ' ';
    cout << fixed;
    cout << yAns;

    /*
    for (auto eq: pos) {
        if (yAns <= eq.a * xAns * xAns + eq.b * xAns + eq.c) {
            cout << "OH!";
        }
    }

    for (auto eq: neg) {
        if (yAns >= eq.a * xAns * xAns + eq.b * xAns + eq.c) {
            cout << "OH!";
        }
    }
    */
}

int main() {
    prepare();
    solve();
}
