#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = long double;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

// #pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

inline void prepare() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const ll mod = 1e9 + 7;
ll p;

struct myString{
    string s;
    vector<bool> was;
    vector<int> where[26];
    vector<ll> hashes;
    vector<bool> checked;

    myString(string &s){
        was.resize(26);
        hashes.resize(26);
        checked.resize(26);
        this->s = s;
        for(int i = 0; i < s.size(); ++i){
            was[s[i] - 'a'] = true;
            where[s[i] - 'a'].push_back(i);
            hashes[s[i] - 'a'] *= p;
            hashes[s[i] - 'a'] += i + 1;
            if(hashes[s[i] - 'a'] >= mod)
                hashes[s[i] - 'a'] %= mod;
        }
    }
};

bool check(vector<myString*> a){
    if(a.size() == 1) return true;
    vector<int> f(26);
    for(auto i : a){
        for(int j = 0; j < 26; ++j){
            if(i->was[j] && !i->checked[j]) f[j]++;
        }
    }
    char g = '1';
    for(int i = 0; i < 26; ++i){
        if(f[i] == a.size()){
            g = i + 'a';
            break;
        }
    }
    if(g == '1') return false;
    map<int, vector<myString*>> lol;
    for(auto i : a){
        i->checked[g - 'a'] = true;
        lol[i->hashes[g - 'a']].push_back(i);
    }
    for(auto i : lol){
        if(!check(i.second)) return false;
    }
    return true;
}

inline void solve() {
    int L, N;
    cin >> L >> N;
    p = L + 1;
    vector<myString*> a(N);
    for(int i = 0; i < N; ++i){
        string s;
        cin >> s;
        a[i] = new myString(s);
    }
    if(check(a)){
        cout << "YES";
    }
    else{
        cout << "NO";
    }
}

int main() {
    prepare();
    solve();
}
