#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

const ld eps = 1e-10;

void Set(ll &mask, int p, int b) {
  if (b == 1) {
    mask |= (1ll << p);
    return;
  }
  if (b == 0) {
    if (mask & (1ll << p)) {
      mask ^= (1ll << p);
      return;
    }
  }
}

bool solve(vector<string> &s, vector<ll> &have, vector<vector<bool> > &mask) {
  int n = s.size();
  if (n == 1)
    return 1;
  ll cur = have[0];
  for (int i = 1; i < n; ++i) {
    cur &= have[i];
  }
  if (cur == 0)
    return 0;
  int any = 0;
  while (!(cur & (1ll << any)))
    ++any;
  map<vector<bool>, vector<int> > mp;
  for (int i = 0; i < n; ++i) {
    Set(have[i], any, 0);
    for (int j = 0; j < s[i].size(); ++j) {
      if (s[i][j] - 'a' == any) {
        mask[i][j] = 0;
      }
    }
    mp[mask[i]].emplace_back(i);
  }
  for (auto &[MASK, poses] : mp) {
    int k = poses.size();
    if (have[poses[0]] == 0)
      continue;
    vector<string> cur_s(k);
    vector<ll> cur_have(k);
    vector<vector<bool> > cur_mask(k) ;
    int it = 0;
    for (int p : poses) {
      cur_s[it] = s[p];
      cur_have[it] = have[p];
      cur_mask[it] = mask[p];
      ++it;
    }
    if (!solve(cur_s, cur_have, cur_mask))
      return 0;
  }
  return 1;
}

signed main() {
  ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
  int l, n;
  cin >> l >> n;
  vector<string> s(n);
  vector<vector<bool> > mask(n, vector<bool>(l, 1));
  vector<ll> have(n, 0);
  for (int i = 0; i < n; ++i) {
    cin >> s[i];
    for (int j = 0; j < l; ++j) {
      Set(have[i], s[i][j] - 'a', 1);
    }
  }
  if (solve(s, have, mask)) {
    cout << "YES";
  } else {
    cout << "NO";
  }
  return 0;
}
