#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;

#define all(a) (a).begin(), (a).end()
#define len(a) int((a).size())

template<typename A, typename B>
ostream& operator<<(ostream &out, pair<A, B> p) { return out << '(' << p.first << ", " << p.second << ')'; }

template<typename A, typename B = typename enable_if<!is_same<A, string>::value, typename A::value_type>::type>
ostream& operator<<(ostream &out, A vec) { out << '{'; string sep; for (B x : vec) out << sep << x, sep = ", "; return out << '}'; }

void dbg_print() { cerr << endl; }
template<typename A, typename... B> void dbg_print(A a, B... b) { cerr << ' ' << a; dbg_print(b...); }

#ifdef LOCAL
    #define dbg(...) cerr << '#' << __LINE__ << " [" << #__VA_ARGS__ << "]:", dbg_print(__VA_ARGS__)
#else
    #define dbg(...)
#endif

signed main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);
	cout << fixed << setprecision(10);

	int n;
	cin >> n;
	vector<array<int, 3>> up, down;
	for (int i = 0; i < n; i++) {
		int a, b, c;
		cin >> a >> b >> c;
		if (a < 0)
			down.push_back({a, b, c});
		else
			up.push_back({a, b, c});
	}

	if (up.empty()) {
		cout << "0 -1000000000000" << '\n';
		return 0;
	}

	if (down.empty()) {
		cout << "0 1000000000000" << '\n';
		return 0;
	}

	auto get_solutions = [&](ld a, ld b, ld c, ld y) -> pair<ld, ld> {
		c -= y;
		ld d = max<ld>(0, b * b - 4 * a * c);
		pair<ld, ld> res{(-b - sqrt(d)) / (2 * a), (-b + sqrt(d)) / (2 * a)};
		if (res.second < res.first)
			swap(res.first, res.second);

		return res;
	};

	ld l = -1e20, r = 1e20;
	for (auto &[a, b, c] : up) {
		ld x = ld(-b) / (2 * a);
		l = max(l, a * x * x + b * x + c);
	}

	for (auto &[a, b, c] : down) {
		ld x = ld(-b) / (2 * a);
		r = min(r, a * x * x + b * x + c);
	}

	auto f = [&](ld y) {
		ld min_r = 1e20, max_l = -1e20;
		for (auto &[a, b, c] : up) {
			auto [cur_l, cur_r] = get_solutions(a, b, c, y);
			min_r = min(min_r, cur_r);
			max_l = max(max_l, cur_l);
		}
		for (auto &[a, b, c] : down) {
			auto [cur_l, cur_r] = get_solutions(a, b, c, y);
			min_r = min(min_r, cur_r);
			max_l = max(max_l, cur_l);
		}
		return min_r - max_l;
	};

	for (int it = 0; it < 100; it++) {
		ld mid1 = (2 * l + r) / 3, mid2 = (l + 2 * r) / 3;
		if (f(mid1) > f(mid2))
			r = mid2;
		else
			l = mid1;
	}

	ld y = (l + r) / 2;
	assert(f(y) > -1e-9);
	ld x = -1e20;
	for (auto &[a, b, c] : up) {
		auto [cur_l, cur_r] = get_solutions(a, b, c, y);
		x = max(x, cur_l);
	}

	for (auto &[a, b, c] : down) {
		auto [cur_l, cur_r] = get_solutions(a, b, c, y);
		x = max(x, cur_l);
	}

	cout << x + 1e-8 << ' ' << y << '\n';
}
