#include<bits/stdc++.h>
#define log log1
using namespace std;
typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vector<int>> vvi;
const char nl = '\n';
const int maxn = 1000000;
const int log = 20;
int n, q;
struct Node;

Node* mass;
int now = 0;
string s;
vector<pair<int, char>> st;

struct Node {
	unordered_map<char, int> go;
	int val;
	int table[log];
	int last[26];
	int d;
	int term;
	int sumterm;
	Node(){}
	Node(int p) {
		table[0] = max(p, 0);
		for(int i = 1; i < log; i++) {
			table[i] = mass[table[i - 1]].table[i - 1];
		}
		term = 0;
		if(p == -1) {
			d = 0;
		} else {
			d = mass[p].d + 1;
		}
	}
};

char get_char(int id1) {
	if(st.empty() || st[0].first > id1) {
		return s[id1];
	}
	int id2 = upper_bound(st.begin(), st.end(), (pair<int, char>){id1, 'z'}) - st.begin() - 1;
	return st[id2].second;
} 

int get_node() {
	return now++;
}

void add_string(int ver, string& s, int curr) {
	if(curr == s.size()) {
		++mass[ver].term;
		return;
	}
	if(mass[ver].go.find(s[curr]) == mass[ver].go.end()) {
		int new1 = get_node();
		mass[new1] = Node(ver);
		mass[ver].go[s[curr]] = new1;
	}
	add_string(mass[ver].go[s[curr]], s, curr + 1);
}
//string st1;
int dfs(int ver, int upper) {
	int ans = mass[ver].term;
	mass[ver].val = upper;
	for(char c = 'a'; c <= 'z'; ++c) {
		auto it = mass[ver].go.find(c);
		if(it == mass[ver].go.end()) {
			continue;
		}
		//st1 += c;
		ans += dfs(it->second, upper + ans);
		//st1.pop_back();
	}
	mass[ver].sumterm = ans;
	//cout << mass[ver].term << ' ' << mass[ver].val << ' ' << st1 << endl;
	return ans;
}

void dfs2(int ver) {
	if(mass[ver].d > n) {
		return;
	}
	for(int i = 0; i < 26; i++) {
		mass[ver].last[i] = ver;
	}
	if(mass[ver].d == n) {
		return;
	}
	for(const auto& el : mass[ver].go) {
		dfs2(el.second);
	}
	for(char c = 'a'; c <= 'z'; ++c) {
		auto it = mass[ver].go.find(c);
		if(it == mass[ver].go.end()) {
			continue;
		}
		mass[ver].last[c - 'a'] = mass[it->second].last[c - 'a'];
	}
}

int calcans(int ver) {
	if(mass[ver].d == n) {
		return mass[ver].val;
	}
	char c = get_char(mass[ver].d);
	int ans = mass[ver].val + mass[ver].term;
	for(char c1 = 'a'; c1 < c; ++c1) {
		auto it = mass[ver].go.find(c1);
		if(it == mass[ver].go.end()) {
			continue;
		}
		ans += mass[it->second].sumterm;
	}
	return ans;

}

int get_par(int ver, int d) {
	if(d > mass[ver].d) {
		return ver;
	}
	for(int i = log - 1; i >= 0; i--) {
		if(mass[mass[ver].table[i]].d >= d) {
			ver = mass[ver].table[i];
		}
	}
	return ver;
}
void update(int pos, char c) {
	while(!st.empty() && st[st.size() - 1].first >= pos) {
		st.pop_back();
	}
	st.push_back({pos, c});
}



int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef _FILE
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
	cin >> n >> q;
	mass = new Node[maxn + 7];
	get_node();
	mass[0] = Node(-1);
	cin >> s;
	for(int i = 0; i < n; i++) {
		string s;
		cin >> s;
		add_string(0, s, 0);
	}
	n = s.size();
	dfs2(0);
	dfs(0, 0);
	int currver = 0;
	for(int i = 0; i < n; i++) {
		auto it = mass[currver].go.find(s[i]);
		if(it == mass[currver].go.end()) {
			break;
		}
		currver = it->second;
	}
	cout << calcans(currver) << '\n';
	//cout << endl;
	//cout << mass[1].val << endl;
	for(int i = 0; i < q; i++) {
		int k;
		char c;
		cin >> k >> c;
		--k;
		currver = get_par(currver, k);
		if(mass[currver].d == k) {
			currver = mass[currver].last[c - 'a'];
		}
		//cout << "D: " << mass[currver].d << endl;
		update(k, c);
		cout << calcans(currver) << '\n';
	}
}