﻿#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <utility>
#include <queue>

using namespace std;

const double EPS = 1e-5;
const double INF = 1e18;

bool ls(double a, double b) {
	return a + EPS < b;
}

int pref_max, pref_min, suff_max, suff_min;

vector<double> answer;
double ans;

void solve(int i, double p) {
	if (p > 1) {
		return;
	}
	double val = max((double)pref_max, suff_max * p) - min((double)pref_min, suff_min * p);
	if (ls(val, ans)) {
		ans = val;
		answer[i] = p;
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif

	int n;
	cin >> n;
	vector<int> a(n);
	for (int& x : a) {
		cin >> x;
	}
	answer.resize(n);
	answer[0] = 0;
	vector<int> min_pref(n);
	vector<int> max_pref(n);
	min_pref[0] = max_pref[0] = a[0];
	for (int i = 1; i < n; ++i) {
		min_pref[i] = min(min_pref[i - 1], a[i]);
		max_pref[i] = max(max_pref[i - 1], a[i]);
	}
	vector<int> min_suff(n);
	vector<int> max_suff(n);
	min_suff[n - 1] = max_suff[n - 1] = a[n - 1];
	for (int i = n - 2; i >= 0; --i) {
		min_suff[i] = min(min_suff[i + 1], a[i]);
		max_suff[i] = max(max_suff[i + 1], a[i]);
	}
	for (int i = 1; i < n; ++i) {
		pref_max = max_pref[i - 1];
		pref_min = min_pref[i - 1];
		suff_max = max_suff[i];
		suff_min = min_suff[i];
		ans = INF;
		solve(i, (double)pref_min / suff_min);
		solve(i, (double)pref_max / suff_max);
		solve(i, 1);
	}
	cout << setprecision(20) << fixed;
	for (double x : answer) {
		cout << 1 - x << '\n';
	}
}