#include <bits/stdc++.h>

using namespace std;


struct node_t {
	array<map<char, pair<int, int>>, 20> next_bin;
	int cnt;
	int depth;

	node_t(int depth): cnt(0), depth(depth) {
	}
};

vector<node_t> nodes;


void add_string(const string& s) {
	int node = 0;
	for(char c: s) {
		if(!nodes[node].next_bin[0].count(c)) {
			nodes[node].next_bin[0][c] = {nodes.size(), 0};
			nodes.emplace_back(nodes[node].depth + 1);
		}
		node = nodes[node].next_bin[0][c].first;
	}
	nodes[node].cnt++;
}


void dfs(int node) {
	int pref = nodes[node].cnt;
	for(auto [c, tup]: nodes[node].next_bin[0]) {
		if(c != '~') {
			int chld = tup.first;
			nodes[node].next_bin[0][c].second = pref;
			dfs(chld);
			pref += nodes[chld].next_bin[0]['~'].second;
		}
	}
	nodes[node].next_bin[0]['~'] = {node, pref};

	for(int i = 1; i < 20; i++) {
		for(auto [c, tup]: nodes[node].next_bin[i - 1]) {
			auto [v, cnt] = tup;
			if(nodes[v].depth - nodes[node].depth < (1 << (i - 1)) || !nodes[v].next_bin[i - 1].count(c)) {
				nodes[node].next_bin[i][c] = tup;
			} else {
				auto res = nodes[v].next_bin[i - 1][c];
				nodes[node].next_bin[i][c] = {res.first, cnt + res.second};
			}
		}
	}
}


int count_node(char c, int n, int node) {
	int ans = 0;
	bool complete = true;
	for(int j = 19; j >= 0 && node != -1; j--) {
		if((n >> j) & 1) {
			auto it = nodes[node].next_bin[j].lower_bound(c);
			// cerr << "+= " << it->second.second << " at " << node << " " << c << " " << j << endl;
			if(it != nodes[node].next_bin[j].end() && it->first == c) {
				ans += it->second.second;
				complete = nodes[it->second.first].depth - nodes[node].depth == (1 << j);
				node = it->second.first;
				if(!complete) {
					break;
				}
			} else {
				complete = false;
				break;
				// node = -1;
			}
		}
	}
	if(!complete) {
		auto it = nodes[node].next_bin[0].lower_bound(c);
		assert(it->first != c);
		ans += it->second.second;
	}
	return ans;
}


signed main() {
	nodes.emplace_back(0);


	int n, q;
	cin >> n >> q;

	vector<tuple<int, char, int, int>> ss;
	string s;
	cin >> s;
	for(int i = 0; i < s.size(); i++) {
		ss.emplace_back(i, s[i], 1, -1);
	}

	for(int i = 0; i < n; i++) {
		string t;
		cin >> t;
		add_string(t);
	}

	dfs(0);


	int node = 0;
	int ans = 0;
	for(int i = 0; i < s.size(); i++) {
		get<3>(ss[i]) = node;
		if(node != -1) {
			char c = s[i];
			auto it = nodes[node].next_bin[0].lower_bound(c);
			ans += it->second.second;
			node = it->first == c ? it->second.first : -1;
		}
	}
	cout << ans << "\n";

	for(int i = 0; i < q; i++) {
		int k;
		char c;
		cin >> k >> c;
		k--;

		int exp;
		auto it = lower_bound(ss.begin(), ss.end(), make_tuple(k, 0, 0, 0));
		if(it != ss.begin()) {
			--it;

			auto& [i, c, n, node] = *it;

			assert(k == 0 || i < k);
			assert(i + n >= k);

			ans -= count_node(c, n, node);
			n = k - i;
			ans += count_node(c, n, node);

			exp = it - ss.begin() + 1;
		} else {
			exp = 0;
		}

		while(ss.size() > exp) {
			auto [i, c, n, node] = ss.back();
			ans -= count_node(c, n, node);
			ss.pop_back();
		}

		int node;
		if(ss.empty()) {
			node = 0;
		} else {
			int i, c, n;
			tie(i, c, n, node) = ss.back();
			for(int j = 19; j >= 0 && node != -1; j--) {
				if((n >> j) & 1) {
					auto it = nodes[node].next_bin[j].find(c);
					node = it->first == c && nodes[it->second.first].depth - nodes[node].depth == (1 << j) ? it->second.first : -1;
				}
			}
		}

		int n = s.size() - k;
		ss.emplace_back(k, c, n, node);
		ans += count_node(c, n, node);

		cout << ans << "\n";
	}

	return 0;
}
