from math import sqrt

inf = 1e299


def get_y(a, b, c, x):
    return a * x ** 2 + b * x + c


def solve(a, b, c):
    d = b ** 2 - 4 * a * c
    return [(-b - sqrt(d)) / (2 * a), (-b + sqrt(d)) / (2 * a)]


def check(x, y):
    for a, b, c in lines:
        if a > 0 and get_y(a, b, c, x) > y:
            return False
        if a < 0 and get_y(a, b, c, x) < y:
            return False
    return True


n = int(input())

lines = [tuple(map(int, input().split())) for _ in range(n)]
# lines.sort(key=lambda x: (x[1] / (2 * x[0]), get_y(x[0], x[1], x[2], x[1] / (2 * x[0]))))

y_min = -inf
y_max = inf
for a, b, c in lines:
    if a > 0:
        y_min = max(y_min, c - ((b ** 2) / (4 * a)))
    else:
        y_max = min(y_max, c - ((b ** 2) / (4 * a)))

y = (y_min + y_max) / 2
xl = -inf
xr = inf
for a, b, c in lines:
    xl_new, xr_new = sorted(solve(a * a, b * a, (c - y) * a))
    xl = max(xl, xl_new)
    xr = min(xr, xr_new)

x = (xl + xr) / 2
# if check(x, y):
print(f'{x:.10f} {y:.10f}')
# else:
#     print(0 / 0)
