#include <iostream>
#include <vector>
#include <random>
#include <algorithm>
#define int long long

using namespace std;

int n, L;
vector <vector <int>> h;

inline bool solve(int mask, vector <int> &id) {
    if (id.size() <= 1)
        return true;
    if (mask == ((1 << n) - 1))
        return false;
    int k = -1;
    for (int j = 0; j < 26; j++) {
        if (mask & (1ll << j))
            continue;
        bool flag = true;
        for (auto &i: id)
            flag &= h[i][j] != 0;
        if (!flag)
            continue;
        k = j;
        break;
    }
    if (k == -1)
        return false;
    mask |= (1ll << k);

    vector <pair <int, int>> upd;
    for (auto &i: id)
        upd.emplace_back(h[i][k], i);
    sort(upd.begin(), upd.end());

    vector <int> cur;
    int last = 0;
    for (auto &[ha, i]: upd) {
        if (last != ha) {
            if (!solve(mask, cur))
                return false;
            cur.clear();
            last = ha;
        }
        cur.push_back(i);
    }
    return solve(mask, cur);
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

    random_device rd;
    mt19937_64 gen(rd());

    cin >> L >> n;
    vector <int> nums(L);
    for (auto &el: nums)
        el = gen();

    h.assign(n, vector <int> (26));
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < L; j++)
            h[i][s[j] - 'a'] += nums[j];
    }

    vector <int> id(n);
    for (int i = 0; i < n; i++)
        id[i] = i;

    if (solve(0, id)) {
        cout << "YES" << endl;
    } else {
        cout << "NO" << endl;
    }

    return 0;
}
