// #pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;
typedef int64_t ll;

constexpr uint64_t mod = (1ull << 61) - 1;
constexpr uint64_t base = 2086;
constexpr int K = 26;

constexpr uint64_t mul(uint64_t a, uint64_t b) {
    __uint128_t res = a * __uint128_t(1) * b;
    uint64_t r = (res >> 61) + (res & mod);
    r = (r >> 61) + (r & mod);
    return r;
}
constexpr uint64_t add(uint64_t a, uint64_t b) {
    return a + b - (a + b >= mod) * mod;
}
constexpr uint64_t power(uint64_t b, uint64_t e) {
    uint64_t r = 1;
    for (; e > 0; e >>= 1) {
        if (e % 2) {
            r = mul(r, b);
        }
        b = mul(b, b);
    }
    return r;
}

constexpr uint64_t r_base = power(base, mod - 2);

constexpr int N = 1e6 + 5;
uint64_t bp[N], r_bp[N];
uint64_t bps[N];

struct Hash {
    std::string s;
    std::vector<uint64_t> prf;
    std::vector<int> helpL, helpG;

    Hash() {
        ;
    }

    void read() {
        std::cin >> s;
        prf.assign(s.size() + 1, 0);
        for (int i = 0; i < s.size(); i++) {
            prf[i + 1] = add(prf[i], mul(s[i], bp[i]));
        }
        std::vector<int> v(K, s.size());
        helpL.assign(s.size(), 0);
        helpG.assign(s.size(), 0);
        for (int i = s.size() - 1; i >= 0; i--) {
            v[s[i] - 'a'] = i;
            char ch = s[i] - 'a';
            if (ch == 0) {
                helpL[i] = s.size();
            } else {
                helpL[i] = *std::min_element(v.begin(), v.begin() + ch);
            }
            if (ch == K - 1) {
                helpG[i] = s.size();
            } else {
                helpG[i] = *std::min_element(v.begin() + ch + 1, v.end());
            }
        }
    }

    uint64_t hash(int l, int r) const {
        return mul(add(prf[r], mod - prf[l]), r_bp[l]);
    }

    bool operator<(const Hash& other) const {
        // return s < other.s;
        int beg = 0, end = std::min(s.size(), other.s.size()) + 1;
        while (beg + 1 < end) {
            int mid = (beg + end) / 2;
            if (hash(0, mid) == other.hash(0, mid)) {
                beg = mid;
            } else {
                end = mid;
            }
        }
        if (beg == other.s.size()) {
            return false;
        }
        if (beg == s.size()) {
            return true;
        }
        return s[beg] < other.s[beg];
    }
};

struct ST {
    struct Data {
        uint64_t hash;
        char push;

        Data() : hash(0), push(0) {
            sizeof(Data);
        }
    };

    int size;
    int sz2;
    std::vector<Data> data;

    inline void merge(int i, int l, int r) {
        int m = (l + r) / 2;
        data[i].hash = add(data[2 * i].hash, mul(bp[m - l], data[2 * i + 1].hash));
        assert(data[i].push == 0);
    }

    inline void upd(int i, int l, int r, char ch) {
        data[i].push = ch;
        data[i].hash = mul(bps[r - l], ch);
    }

    inline void push(int i, int l, int r) {
        if (data[i].push != 0) {
            int m = (l + r) / 2;
            upd(2 * i, l, m, data[i].push);
            upd(2 * i + 1, m, r, data[i].push);
            data[i].push = 0;
        }
    }

    ST(int n) {
        sz2 = n;
        size = 1 << 32 - __builtin_clz(n - 1);
        data.assign(2 * size, Data());
    }

    void update(int i, int l, int r, int ql, int qr, char ch) {
        if (r <= ql || qr <= l) {
            return;
        } else if (ql <= l && r <= qr) {
            upd(i, l, r, ch);
        } else {
            push(i, l, r);

            int m = (l + r) / 2;
            update(2 * i, l, m, ql, qr, ch);
            update(2 * i + 1, m, r, ql, qr, ch);

            merge(i, l, r);
        }
    }

    void update(int l, int r, char ch) {
        update(1, 0, sz2, l, r, ch);
    }

    bool comp(int i, int l, int r, const Hash& hs) {
        if (l >= hs.s.size()) {
            return true;
        }
        if (hs.s.size() >= r) {
            if (data[i].hash == hs.hash(l, r)) {
                return hs.s.size() < r;
            }
        }
        if (l + 1 == r) {
            return data[i].hash > hs.hash(l, r);
        } else {
            push(i, l, r);
            int m = (l + r) / 2;
            if (hs.s.size() >= m && data[2 * i].hash == hs.hash(l, m)) {
                return comp(2 * i + 1, m, r, hs);
            } else {
                return comp(2 * i, l, m, hs);
            }
        }
    }

    int lcp(int i, int l, int r, const Hash& hs) {
        if (l >= hs.s.size()) {
            return hs.s.size();
        }
        if (hs.s.size() >= r) {
            if (data[i].hash == hs.hash(l, r)) {
                return r;
            }
        }
        if (l + 1 == r) {
            return l;
        } else {
            push(i, l, r);
            int m = (l + r) / 2;
            if (hs.s.size() >= m && data[2 * i].hash == hs.hash(l, m)) {
                return lcp(2 * i + 1, m, r, hs);
            } else {
                return lcp(2 * i, l, m, hs);
            }
        }
    }

    void push0() {
        int r = sz2;
        int i = 1;
        while (r > 1) {
            push(i, 0, r);
            i *= 2;
            r /= 2;
        }
    }

    bool comp(const Hash& hs) {
        int r = sz2;
        int i = 1;
        while (hs.s.size() < r / 2) {
            r /= 2;
            i *= 2;
        }
        return comp(i, 0, r, hs);
    }

    int lcp(const Hash& hs) {
        int r = sz2;
        int i = 1;
        while (hs.s.size() < r / 2) {
            r /= 2;
            i *= 2;
        }
        return lcp(i, 0, r, hs);
    }
};

void init() {
    bp[0] = 1;
    r_bp[0] = 1;
    for (int i = 1; i < N; i++) {
        bp[i] = mul(bp[i - 1], base);
        r_bp[i] = mul(r_bp[i - 1], r_base);
    }
    for (int i = 0; i < N - 1; i++) {
        bps[i + 1] = add(bps[i], bp[i]);
    }
}

// std::string randStr(int n = -1) {
//     if (n == -1) {
//         n = rand() % 10 + 1;
//     }
//     std::string s(n, '-');
//     for (auto& ch : s) {
//         ch = 'a' + (rand() % 2);
//     }
//     return s;
// }

int32_t main() {
    // #ifdef LOCAL
    // freopen("test.in", "r", stdin);
    // #endif

    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    init();

    int n, q;
    std::cin >> n >> q;
    std::string s;
    std::cin >> s;

    std::vector<Hash> input(n);
    for (auto& hs : input) {
        hs.read();
    }
    std::sort(input.begin(), input.end());

    ST st(s.size());
    for (int i = 0; i < s.size(); i++) {
        st.update(i, i + 1, s[i]);
    }
    // for (int i = s.size(); i < st.size; i++) {
    //     st.update(i, i + 1, 'a' - 1);
    // }

    int lastInd = -1;

    int k;
    char ch;
    auto cum2 = [&]() -> int {
        int beg = -1, end = input.size();
        while (beg + 1 < end) {
            int mid = (beg + end) / 2;

            bool b1 = st.comp(input[mid]);
            // bool b2 = input[mid].s < s;
            // assert(b1 == b2);
            if (b1) {
                beg = mid;
            } else {
                end = mid;
            }
        }
        return end;
    };
    auto cum = [&]() {
        st.push0();
        if (lastInd == -1) {
            int beg = -1, end = input.size();
            while (beg + 1 < end) {
                int mid = (beg + end) / 2;

                bool b1 = st.comp(input[mid]);
                // bool b2 = input[mid].s < s;
                // assert(b1 == b2);
                if (b1) {
                    beg = mid;
                } else {
                    end = mid;
                }
            }
            lastInd = end;
        } else {
            bool inc = false;
            bool dec = false;
            if (lastInd != n) {
                if (st.comp(input[lastInd])) {
                    inc = true;
                }
            }
            if (lastInd != 0) {
                if (!st.comp(input[lastInd - 1])) {
                    dec = true;
                }
            }
            assert(!(dec && inc));
            if (dec) {
                int l = st.lcp(input[lastInd - 1]);
                uint64_t h = input[lastInd - 1].hash(0, l);
                int beg = -1, end = lastInd;
                while (beg + 1 < end) {
                    int mid = (beg + end) / 2;
                    bool b;
                    if (input[mid].s.length() <= l) {
                        b = false;
                    } else {
                        if (input[mid].hash(0, l) == h) {
                            if (input[mid].s[l] != ch) {
                                b = input[mid].s[l] < ch;
                            } else {
                                int x = std::max(input[mid].helpL[l], input[mid].helpG[l]);
                                if (x >= s.size()) {
                                    b = true;
                                } else {
                                    if (input[mid].helpG[l] != input[mid].helpL[l]) {
                                        b = input[mid].helpG[l] < input[mid].helpL[l];
                                    } else {
                                        b = input[mid].s.length() >= s.size();
                                    }
                                }
                            }
                        } else {
                            b = false;
                        }
                    }

                    if (b) {
                        end = mid;
                    } else {
                        beg = mid;
                    }
                }
                lastInd = end;
            } else if (inc) {
                int l = st.lcp(input[lastInd]);

                uint64_t h = input[lastInd].hash(0, l);
                int beg = lastInd, end = n;
                while (beg + 1 < end) {
                    int mid = (beg + end) / 2;
                    bool b;
                    if (input[mid].s.length() <= l) {
                        b = false;
                    } else {
                        if (input[mid].hash(0, l) == h) {
                            if (input[mid].s[l] != ch) {
                                b = input[mid].s[l] < ch;
                            } else {
                                int x = std::max(input[mid].helpL[l], input[mid].helpG[l]);
                                if (x >= s.size()) {
                                    b = false;
                                } else {
                                    if (input[mid].helpG[l] != input[mid].helpL[l]) {
                                        b = input[mid].helpG[l] > input[mid].helpL[l];
                                    } else {
                                        b = input[mid].s.length() < s.size();
                                    }
                                }
                            }
                        } else {
                            b = false;
                        }
                    }

                    if (b) {
                        beg = mid;
                    } else {
                        end = mid;
                    }
                }
                lastInd = end;
            }
        }
        int ind = cum2();
        std::cerr << ind << " " << lastInd << std::endl;
        assert(lastInd == ind);

        std::cout << lastInd << "\n";
        // std::cout.flush();
    };

    cum();

    for (int i = 0; i < q; i++) {
        std::cin >> k >> ch;
        k--;
        st.update(k, s.size(), ch);
        // std::fill(s.begin() + k, s.end(), ch);

        cum();
    }

    return 0;
}