#include <bits/stdc++.h>

using namespace std;
typedef int64_t ll;

using l_double = long double;
#define double l_double

constexpr double eps = 1e-10;

struct Arc {
    double a, b, c;

    void read() {
        std::cin >> a >> b >> c;
    }

    double operator()(double x) const {
        return a * x * x + b * x + c;
    }

    Arc operator-(const Arc& other) const {
        return Arc{a - other.a, b - other.b, c - other.c};
    }

    double findRt() const {
        if (-eps < a && a < eps) {
            return -c / b;
        }
        double D = b * b - 4 * a * c;
        assert(D >= -eps);
        D = std::max<double>(D, 0);
        return (-sqrtl(D) - b) / (2 * a);
    }

    double vtx() const {
        return -b / (2 * a);
    }
};

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    std::cout.precision(8);
    std::cout << std::fixed;

    int n;
    std::cin >> n;
    std::vector<Arc> vec(n);
    for (auto& a : vec) {
        a.read();
    }

    std::sort(vec.begin(), vec.end(), [](auto a, auto b) { return a.vtx() < b.vtx(); });
    auto it = std::find_if(vec.begin(), vec.end(), [](const auto& a) { return a.a > 0; });
    if (it == vec.end()) {
        std::cout << 0 << " " << -1.1e9 << std::endl;
        return 0;
    }

    std::swap(*it, vec.front());
    Arc ar = vec.front();
    vec.erase(vec.begin());

    double ans = -1e18;
    for (auto& ar2 : vec) {
        double d = (ar - ar2).findRt();
        ans = std::max(ans, d);
    }

    std::cout << ans << " " << ar(ans) << std::endl;

    return 0;
}