#include <iostream>
#include "vector"
#include "algorithm"
#include "map"
using namespace std;
#define all(x) (x).begin(), (x).end()
typedef long long ll;
#define int long long
const int INF = 1e9 + 7;
int mod = 1e9 + 7;
int bd = 1e9 + 14;
int getsum(vector<int> a) {
    int res = 0;
    int n = a.size();
    for (int i = 0; i < n; ++i) {
        res += (i + 1) * (n - i) % mod * a[i];
        res %= mod;
    }
    return res;
}
int getsummin(vector<int> a) {
    int n = a.size();
    vector<int> preless(n), nextless(n);
    for (int i = 0; i < n; ++i) {
        preless[i] = i - 1;
        while (preless[i] != -1 and a[preless[i]] > a[i])
            preless[i] = preless[preless[i]];
    }
    int res = 0;
    for (int i = n - 1; i >= 0; --i) {
        nextless[i] = i + 1;
        while (nextless[i] != n and a[nextless[i]] >= a[i])
            nextless[i] = nextless[nextless[i]];
        res += (nextless[i] - i) * (i - preless[i]) % mod * a[i];
        res %= mod;
    }
    return  res;
}
struct segtree{ //MIN
    int sz;
    vector<int> tree;
    void make(int n, vector<int> a) {
        sz = 1;
        while (sz < n)
            sz *= 2;
        tree.assign(sz * 2, 1e10);
        for (int i = 0; i < n; ++i) {
            tree[i + sz] = a[i];
        }
        for (int i = sz - 1; i > 0; --i) {
            tree[i] = min(tree[i * 2], tree[i * 2 + 1]);
        }
    }
    int get(int l, int r) {
        l += sz;
        r += sz;
        int res = 1e10;
        while (l <= r) {
            if (l % 2 == 1) {
                res = min(res, tree[l]);
                l++;
            }
            if (r % 2 == 0) {
                res = min(res, tree[r]);
                r--;
            }
            l /= 2;
            r /= 2;
        }
        return res;
    }
};
int solve(vector<int> a, vector<int> b, int k) {
    int res = getsum(a);
    map<int, vector<int>> prefind;
    int prefsum = 0;
    prefind[0].push_back(0);
    segtree sg;
    vector<int> psum(a.size() + 1);
    sg.make(b.size(), b);
    for (int i = 0; i < a.size(); ++i) {
        prefsum += a[i];
        psum[i + 1] = psum[i] + a[i];
        prefind[prefsum % k].push_back(i + 1);
    }
    for (auto i : prefind) {
        vector<int> nums, bspdr;
        //for (auto j : i.second)
        //    cout << j << ' ';
        //cout << endl;
        for (int j = 0; j + 1 < i.second.size(); ++j) {
            int val = sg.get(i.second[j], i.second[j + 1] - 1);
            //cout << val << endl;
            if (val == bd) {
                val = (psum[i.second[j + 1]] - psum[i.second[j]]) % mod;
                res -= getsummin(nums);
                nums.clear();
                bspdr.push_back(val);
                res %= mod;
            } else {
                res -= getsum(bspdr);
                bspdr.clear();
                res %= mod;
                nums.push_back(val);
            }
        }
        //for (auto j : bspdr)
        //    cout << j << ' ';
        //cout << '\n';
        res -= getsummin(nums);
        res -= getsum(bspdr);
        res %= mod;
    }
    res += mod;
    res %= mod;
    return res;
}
signed main(){
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int k, n;
    cin >> n >> k;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        int x = 0, y = 0;
        cin >> x >> y;
        a[i] = max(x, y);
        b[i] = a[i] - min(x, y);
        if (b[i] % k == 0)
            b[i] = bd;
    }
    cout << solve(a, b, k);
}
