#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <cassert>
#include <array>

using namespace std;


#define ll long long
#define ld long double
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()


const int alph = 26;
const int logn = 21;


struct node {
	array<int, alph> go;
	array<int, alph> nxt;
	array<int, logn> up;
	int c;
	int sm;
	int cm;
	int ln;

	node() {
		c = 0;
		cm = 0;
		sm = 0;
		ln = 0;
		for (int i = 0; i < alph; ++i) {
			go[i] = -1;
			nxt[i] = -1;
		}
	}
};


const int mxbrsz = 1e6 + 1000;


vector<node> br;
int brsz;


void dfs(int v, int n, int p) {
	br[v].sm = br[v].c;
	for (int i = 0; i < alph; ++i) {
		br[v].nxt[i] = v;
	}
	br[v].up[0] = p;
	for (int i = 1; i < logn; ++i) {
		br[v].up[i] = br[br[v].up[i - 1]].up[i - 1];
	}
	for (int i = 0; i < alph; ++i) {
		int to = br[v].go[i];
		if (to != -1) {
			br[to].cm += br[v].cm + br[v].sm;
			br[to].ln = br[v].ln + 1;
			dfs(to, n, v);
			br[v].sm += br[to].sm;
			if (br[v].ln < n) {
				br[v].nxt[i] = br[to].nxt[i];
			}
		}
	}
}


int new_node() {
	return brsz++;
}


void build() {
	brsz = 0;
	br.resize(mxbrsz);
	new_node();
}


void add_str(vector<int>& s) {
	int v = 0;
	int n = s.size();
	for (int i = 0; i < n; ++i) {
		if (br[v].go[s[i]] == -1) {
			br[v].go[s[i]] = new_node();
		}
		v = br[v].go[s[i]];
	}
	br[v].c += 1;
}


int get_up(int v, int x) {
	for (int i = 0; i < logn; ++i) {
		if ((x >> i) & 1) {
			v = br[v].up[i];
		}
	}
	return v;
}


int get_smlr(int v, int c) {
	if (c == -1) {
		return br[v].cm;
	}
	int res = br[v].cm + br[v].c;
	for (int i = 0; i < c; ++i) {
		int to = br[v].go[i];
		if (to != -1) {
			res += br[to].sm;
		}
	}
	return res;
}


int n, q;
vector<int> s;
vector<int> d;


void get_str(vector<int>& a) {
	string x;
	cin >> x;
	a.resize(x.size());
	for (int i = 0; i < x.size(); ++i) {
		a[i] = x[i] - 'a';
	}
}


int find_s() {
	int v = 0;
	for (int i = 0; i < s.size(); ++i) {
		if (br[v].go[s[i]] == -1) {
			return v;
		}
		v = br[v].go[s[i]];
	}
	return v;
}


int get_smlr(int v) {
	if (br[v].ln == s.size()) {
		return get_smlr(v, -1);
	}
	return get_smlr(v, s[br[v].ln]);
}


int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	build();
	cin >> n >> q;
	get_str(s);
	for (int i = 0; i < n; ++i) {
		get_str(d);
		add_str(d);
	}
	dfs(0, s.size(), 0);
	int v = find_s();
	int x = get_smlr(v);
	cout << x << "\n";
	for (int i = 0; i < q; ++i) {
		int k;
		char c;
		cin >> k >> c;
		k -= 1;
		if (br[v].ln < k) {
			
		}
		else {
			v = get_up(v, br[v].ln - k);
			v = br[v].nxt[c - 'a'];
			if (br[v].ln < s.size()) {
				x = get_smlr(v, c - 'a');
			}
			else {
				x = get_smlr(v, -1);
			}
		}
		cout << x << "\n";
	}
	return 0;
}