#pragma GCC optimize("O3,unroll-loops,fast-math")


#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <cassert>
#include <array>
#include <set>
#include <map>
#include <deque>

using namespace std;


#define ll long long
#define ld long double
#define flt double
#define pb push_back
#define emb emplace_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()


const flt inf = 1e20;


int n;
vector<flt> a, b, c;


inline flt min(flt x, flt y) {
	if (x < y) {
		return x;
	}
	return y;
}

inline flt max(flt x, flt y) {
	if (x < y) {
		return y;
	}
	return x;
}



inline flt get_mn(flt x) {
	flt res = inf;
	for (int i = 0; i < n; ++i) {
		if (a[i] < 0) {
			res = min(res, a[i] * x * x + b[i] * x + c[i]);
		}
	}
	return res;
}


inline flt get_mx(flt x) {
	flt res = -inf;
	for (int i = 0; i < n; ++i) {
		if (a[i] > 0) {
			res = max(res, a[i] * x * x + b[i] * x + c[i]);
		}
	}
	return res;
}


inline flt f(flt x) {
	flt mx = -inf;
	flt mn = inf;
	for (int i = 0; i < n; ++i) {
		if (a[i] > 0) {
			mx = max(mx, a[i] * x * x + b[i] * x + c[i]);
		}
		else {
			mn = min(mn, a[i] * x * x + b[i] * x + c[i]);
		}
	}
	return mn - mx;
}


signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	a.resize(n);
	b.resize(n);
	c.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i] >> b[i] >> c[i];
	}
	flt l = -1e5;
	flt r = 1e5;
	for (int i = 0; i < 70; ++i) {
		flt m1 = (l + l + r) / 3;
		flt m2 = (l + r + r) / 3;
		if (f(m1) > f(m2)) {
			r = m2;
		}
		else {
			l = m1;
		}
	}
	flt x = (l + r) / 2;
	flt y = (get_mn(x) + get_mx(x)) / 2;
	cout << fixed << setprecision(20) << x << " " << y << "\n";
}

/*
4
1 2 3
1 -3 -5
-1 3 4
-2 4 6

*/