#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <cassert>
#include <array>
#include <map>



using namespace std;


#define ll long long
#define ld long double
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()


const int alph = 26;


const int mxbrsz = 1e6 + 1000;


struct node {
	int l = -1;
	int r = -1;
	vector<int> x;
};


int ln;
int n;
vector<vector<int>> a;
vector<int> smb;
vector<node> br;
int brsz;


void build() {
	br.resize(mxbrsz);
}


int new_node() {
	br[brsz].l = -1;
	br[brsz].r = -1;
	return brsz++;
}


void add_str(int i, int c) {
	int v = 0;
	for (int j = 0; j < ln; ++j) {
		if (a[i][j] == c) {
			if (br[v].r == -1) {
				br[v].r = new_node();
			}
			v = br[v].r;
		}
		else {
			if (br[v].l == -1) {
				br[v].l = new_node();
			}
			v = br[v].l;
		}
	}
	br[v].x.push_back(i);
}


void dfs(int v, vector<vector<int>>& x) {
	if (br[v].x.size() > 1) {
		x.push_back(br[v].x);
	}
	br[v].x.clear();
	if (br[v].r != -1) {
		dfs(br[v].r, x);
	}
	if (br[v].l != -1) {
		dfs(br[v].l, x);
	}
}


bool solve(vector<int> &x, int msk) {
	if (x.size() <= 1) {
		return true;
	}
	brsz = 0;
	new_node();
	int m = msk;
	for (auto i : x) {
		m = (m & (smb[i]));
	}
	if (m == 0) {
		return false;
	}
	int c = -1;
	for (int i = 0; i < alph; ++i) {
		if ((m >> i) & 1) {
			c = i;
			break;
		}
	}
	for (auto i : x) {
		add_str(i, c);
	}
	x.clear();
	vector<vector<int>> nx;
	dfs(0, nx);
	msk -= (1 << c);
	for (auto& f : nx) {
		if (!solve(f, msk)) {
			return false;
		}
	}
	return true;
}


bool solve() {
	build();
	vector<int> x(n);
	for (int i = 0; i < n; ++i) {
		x[i] = i;
	}
	return solve(x, (1 << alph) - 1);
}


int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> ln >> n;
	a.assign(n, vector<int>(ln));
	smb.assign(n, 0);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < ln; ++j) {
			char c;
			cin >> c;
			a[i][j] = c - 'a';
			smb[i] = (smb[i] | (1 << a[i][j]));
		}
	}
	vector<int> x(n);
	for (int i = 0; i < n; ++i) {
		x[i] = i;
	}
	if (solve()) {
		cout << "YES" << "\n";
	}
	else {
		cout << "NO" << "\n";
	}
	return 0;
}
