#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <cassert>
#include <array>
#include <map>
#include <random>


using namespace std;
#define int long long
const int INF = 1e9 + 1;
const int mod = 1e9 + 7;
int k;
vector <int> t;
vector <pair <int, int>> a;

void build(int v, int l, int r) {
	if (l == r) {
		if ((a[l].second - a[l].first) % k != 0) t[v] = (a[l].second - a[l].first);
		return;
	}
	int m = (l + r) / 2;
	build(2 * v, l, m);
	build(2 * v + 1, m + 1, r);
	t[v] = min(t[2 * v], t[2 * v + 1]);
}

int get_min(int v, int l, int r, int A, int B) {
	if (l > B || A > r) return INF;
	if (A <= l && r <= B) return t[v];
	int m = (l + r) / 2;
	return min(get_min(2 * v, l, m, A, B), get_min(2 * v + 1, m + 1, r, A, B));
}

inline int solve1(int n, vector <pair <int, int>>& aa) {
	a = aa;
	for (int i = 0; i < n; ++i) {
		if (a[i].first > a[i].second) swap(a[i].first, a[i].second);
	}
	t.assign(4 * n, INF);
	build(1, 0, n - 1);
	int answer = 0;
	for (int i = 0; i < n; ++i) {
		answer += ((i + 1) * (n - i) % mod) * a[i].second;
		answer %= mod;
	}
	map <int, pair <int, int>> flex;
	flex[0] = make_pair(0, 1);
	int last_good = 0, kek = 0, cur_sum = 0;
	vector <int> pref_sum(n + 1);
	vector <int> all_osts = { 0 };
	for (int i = 0; i < n; ++i) {
		cur_sum += a[i].second;
		cur_sum %= mod;
		pref_sum[i + 1] = cur_sum;
		int my_ost = (a[i].second - a[i].first) % k;
		all_osts.push_back(cur_sum % k);
		if (my_ost == 0) {
			kek += cur_sum * flex[cur_sum % k].second - flex[cur_sum % k].first;
			kek = (kek % mod + mod) % mod;
		}
		else {
			for (int j = last_good; j <= i; ++j) flex[pref_sum[j] % k] = make_pair(0, 0);
			last_good = i + 1;
		}
		flex[cur_sum % k].second++;
		flex[cur_sum % k].first += cur_sum;
		flex[cur_sum % k].first %= mod;
	}
	answer = (answer - kek + mod) % mod;
	sort(all_osts.begin(), all_osts.end());
	all_osts.resize(unique(all_osts.begin(), all_osts.end()) - all_osts.begin());
	map <int, int> num_ost;
	vector <vector <int>> all((int)all_osts.size());
	for (int i = 0; i < (int)all_osts.size(); ++i) num_ost[all_osts[i]] = i;
	for (int i = 0; i <= n; ++i) all[num_ost[pref_sum[i] % k]].push_back(i);
	for (auto& i : all) {
		vector <array <int, 3>> st;
		int cha = 0;
		for (int j = 1; j < (int)i.size(); ++j) {
			int my_min = get_min(1, 0, n - 1, i[j - 1], i[j] - 1);
			if (my_min != INF) {
				array <int, 3> me;
				me[0] = my_min;
				while (!st.empty() && st.back()[0] >= my_min) {
					cha -= st.back()[1];
					st.pop_back();
				}
				me[1] = j - cha;
				me[2] = me[0] * me[1];
				if (!st.empty()) me[2] += st.back()[2];
				me[2] %= mod;
				st.push_back(me);
				answer = (answer - me[2] + mod) % mod;
				cha = j;
			}
			else {
				if (!st.empty()) answer = (answer - st.back()[2] + mod) % mod;
			}
		}
	}
	return answer;
}

inline int solve2(int n, vector <pair <int, int>>& aa) {
	int result = 0;
	for (int i = 0; i < n; ++i) {
		int current_sum = 0, min_not_k = INF;
		for (int j = i; j < n; ++j) {
			current_sum += max(aa[j].first, aa[j].second);
			if (abs(aa[j].first - aa[j].second) % k != 0) min_not_k = min(min_not_k, abs(aa[j].first - aa[j].second));
			if (current_sum % k != 0) result += current_sum;
			else if (min_not_k != INF) result += current_sum - min_not_k;
		}
	}
	return result;
}
signed main() {
	if (1) {
		int n;
		cin >> n >> k;
		vector <pair <int, int>> aa(n);
		for (int i = 0; i < n; ++i) cin >> aa[i].first >> aa[i].second;
		cout << solve1(n, aa);
	}
	else {
		srand(1303);
		int cnt;
		cin >> cnt;
		while (cnt--) {
			cout << cnt << "\n"; 
			int n = rand() % 20 + 1;
			k = rand() % 10 + 1;
			vector <pair <int, int>> aa(n);
			for (int i = 0; i < n; ++i) {
				aa[i].first = rand() % 20 + 1;
				aa[i].second = rand() % 20 + 1;
			}
			if (solve1(n, aa) != solve2(n, aa)) {
				cout << n << " " << k << "\n";
				for (auto i : aa) cout << i.first << " " << i.second << "\n";
				return 0;
			}
		}
	}
	
}

/*
3 5
8 9
2 2
3 8
*/