#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <unordered_set>
#include <set>
#include <complex>
#include <deque>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()

long double count(int mx1, int mn1, int mx2, int mn2, long double t) {
    return max((long double)mx1, (long double)mx2 * t) -  min((long double)mn1, (long double)mn2 * t);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    vector<int> prefmx(n + 1, -1e9);
    vector<int> prefmn(n + 1, 1e9);
    for (int i = 1; i <= n; i++) {
        prefmx[i] = max(prefmx[i - 1], v[i - 1]);
        prefmn[i] = min(prefmn[i - 1], v[i - 1]);
    }
    vector<int> sufmx(n + 1, -1e9);
    vector<int> sufmn(n + 1, 1e9);
    for (int i = n - 1; i >= 0; i--) {
        sufmx[i] = max(sufmx[i + 1], v[i]);
        sufmn[i] = min(sufmn[i + 1], v[i]);
    }
    vector<long double> ans(n);
    for (int i = n - 1; i >= 1; i--) {
        vector<long double> vars = {0, 1};
        int mx1 = prefmx[i];
        int mx2 = sufmx[i];
        int mn1 = prefmn[i];
        int mn2 = sufmn[i];
        if (mn2 > mn1) {
            vars.push_back((long double)mn1 / mn2);
        }
        if (mx2 > mx1) {
            vars.push_back((long double)mx1 / mx2);
        }
        sort(vars.rbegin(), vars.rend());
        long double now = 1e10;
        long double best = 0;
        for (auto t : vars) {
            if (now >= count(mx1, mn1, mx2, mn2, t)) {
                now = count(mx1, mn1, mx2, mn2, t);
                best = t;
            }
        }
        ans[i] = 1 - best;
    }
    ans[0] = 1;
    for (auto x : ans) {
        cout << fixed << setprecision(15) << x << ' ';
    }
}
