#ifdef _MSC_VER
#define _CRT_SECURE_NO_WARNINGS
#include <__msvc_all_public_headers.hpp>
#else
#include <bits/stdc++.h>
#include <bits/extc++.h>
using namespace __gnu_pbds;
template<typename T>
using ordset = tree<T, null_type, std::less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#endif

#define all(q) q.begin(), q.end()
#define Please return
#define AC 0
#define nl '\n'

using namespace std;
using ll = long long;
using ld = long double;
using cmpl = complex<long double>;

template<typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& x) {
	return in >> x.first >> x.second;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& out, const pair<T1, T2>& x) {
	return out << x.first << ' ' << x.second;
}

template<typename T>
istream& operator>>(istream& in, vector <T>& x) {
	for (auto& p : x)
		in >> p;
	return in;
}

template<typename T>
ostream& operator<<(ostream& out, const vector <T>& x) {
	for (auto& p : x)
		out << p << ' ';
	return out;
}

const ll mod = (int)1e9 + 7;

struct SegTree
{
	vector<int> a;
	vector<int> v;
	
	SegTree(const vector<int>& v): v(v)
	{
		a.resize(v.size() * 4);
		build(0, 0, v.size());
	}

	void build(int i, int l, int r)
	{
		if (l == r)
			return;
		if (l + 1 == r)
		{
			a[i] = l;
			return;
		}

		int m = (l + r) / 2;
		build((i * 2) + 1, l, m);
		build((i * 2) + 2, m, r);
		a[i] = (v[a[i * 2 + 1]] < (v[a[i * 2 + 2]])) ? a[i * 2 + 1] : a[i * 2 + 2];
	}

	int get(int i, int l, int r, int ql, int qr)
	{
		if (l >= qr || r <= ql)
			return -1;
		if (ql <= l && r <= qr)
			return a[i];

		int m = (l + r) / 2;
		int x = get(i * 2 + 1, l, m, ql, qr);
		int y = get(i * 2 + 2, m, r, ql, qr);
		if (x == -1)
			return y;
		if (y == -1)
			return x;
		if (a[x] < a[y])
			return x;
		return y;
	}
};

const int INF = 2 * (int)1e9;

struct Counter
{
	ll curSum =  0;
	map<int, int> cnt;

	void add(int x)
	{
		curSum = (curSum + cnt[x]) % mod;
		++cnt[x];
	}

	void erase(int x)
	{
		--cnt[x];
		curSum = (curSum - cnt[x] + mod) % mod;
	}
};

int n = 0;

ll getRes(int l, int r, Counter& cnt, SegTree& st, const vector<int>& a, const vector<ll>& p)
{
	if (l == r)
		return 0;

	int pos = st.get(0, 0, n, l, r);
	if (a[pos] == INF)
		return 0;

	ll res = (cnt.curSum * a[pos]) % mod;

	if (l + 1 == r)
		return res;

	if (pos > (l + r) / 2)
	{
		for (int i = pos; i <= r; ++i)
			cnt.erase(p[i]);

		Counter cntRight;
		for (int i = pos + 1; i <= r; ++i)
			cntRight.add(p[i]);

		res = (res - (cnt.curSum * a[pos]) % mod + mod) % mod;
		res = (res - (cntRight.curSum * a[pos]) % mod + mod) % mod;

		res += getRes(l, pos, cnt, st, a, p);
		res += getRes(pos + 1, r, cntRight, st, a, p);
		res %= mod;

		for (int i = pos; i <= r; ++i)
			cnt.add(p[i]);
	}
	else
	{
		for (int i = l; i <= pos; ++i)
			cnt.erase(p[i]);

		Counter cntLeft;
		for (int i = l; i <= pos; ++i)
			cntLeft.add(p[i]);

		res = (res - (cnt.curSum * a[pos]) % mod + mod) % mod;
		res = (res - (cntLeft.curSum * a[pos]) % mod + mod) % mod;

		res += getRes(l, pos, cntLeft, st, a, p);
		res += getRes(pos + 1, r, cnt, st, a, p);
		res %= mod;

		for (int i = l; i <= pos; ++i)
			cnt.add(p[i]);
	}
	return res;
}

int main(int argc, char* argv[]) {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	cout.precision(20);
	if (argc > 1) {
		freopen(argv[1], "r", stdin);
	}
	if (argc > 2) {
		freopen(argv[2], "w", stdout);
	}

	int k = 0;
	cin >> n >> k;

	vector<int> a(n), b(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> a[i] >> b[i];
		if (b[i] > a[i])
			swap(a[i], b[i]);
	}

	ll sum = 0;
	for (int i = 0; i < n; ++i)
		sum = (sum + ((a[i] * (i + 1)) % mod) * (n - i)) % mod;

	vector<int> dif(n);
	for (int i = 0; i < n; ++i)
	{
		dif[i] = a[i] - b[i];
		if (dif[i] % k == 0)
			dif[i] = INF;
	}

	vector<ll> p(n + 1);
	partial_sum(all(a), p.begin() + 1);
	for (int i = 0; i <= n; ++i)
		p[i] %= k;
	
	Counter cnt;
	for(int i = 0; i <= n; ++i)
		cnt.add(p[i]);
	SegTree st(dif);
	sum = (sum - getRes(0, n, cnt, st, dif, p) + mod) % mod;

	vector<int> ts;
	for (int i = 0; i < n; ++i)
	{
		if (dif[i] == INF)
			ts.push_back(a[i]);
		else
		{
			if (!ts.empty())
			{
				int k = ts.size();
				for (int j = 0; j < k; ++j)
					sum = (sum - (((a[ts[j]] * (j + 1)) % mod) * (k - j)) % mod + mod) % mod;
				ts.clear();
			}
		}
	}

	cout << sum << "\n";

	Please AC;
}