﻿#define _CRT_SECURE_NO_WARNINGS

#include <bitset>
#include <iostream>
#include <numeric>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <cmath>
#include <utility>
#include <cassert>
#include <vector>

#ifdef ONLINE_JUDGE
#define cerr if (false) cerr
#endif

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

//#define int ll
#define sz(x) int(x.size())
#define dbg(x) cerr << #x << " = " << x << '\n';

using namespace std;

void solve() {
  int n;
  cin >> n;
  vector<ll> a(n);
  for (int i = 0; i < n; i++)
    cin >> a[i];

  vector<ll> prMax(n + 1), prMin(n + 1), sfMax(n + 1), sfMin(n + 1), sfSum(n + 1);

  prMax[0] = 0, prMin[0] = 1e10, sfMin[n] = 1e10, sfMax[n] = 0;

  for (int i = 1; i < n; i++)
  {
    prMax[i] = max(a[i - 1], prMax[i - 1]);
    prMin[i] = min(a[i - 1], prMin[i - 1]);
  }

  for (int i = n - 1; i >= 0; i--)
  {
    sfMax[i] = max(sfMax[i + 1], a[i]);
    sfMin[i] = min(sfMin[i + 1], a[i]);
    sfSum[i] = sfSum[i + 1] + a[i];
  }

  vector<ld> ans(n);

  auto get = [&](int i, ld t) -> pair<ld, ld> {
    ld Min = min((ld)prMin[i], sfMin[i] * t);
    ld Max = max((ld)prMax[i], sfMax[i] * t);
    return { Max - Min, t * sfSum[i] };
  };

  auto check = [&](int i, ld L, ld R) -> vector<ld> {
    R = min(R, (ld)1);
    L = max(L, (ld)0);

    if (L > R) return { 1e10, 0, 1 };

    ld tAns = 1.0;
    ld ans = prMax[i];
    ld w = sfSum[i];
    auto [dif, cost] = get(i, L);
    if (dif < ans)
    {
      ans = dif;
      w = cost;
      tAns = L;
    } else if (dif == ans && cost < w)
    {
      w = cost;
      tAns = L;
    }

    auto [dif1, cost1] = get(i, R);
    if (dif1 < ans)
    {
      ans = dif1;
      w = cost1;
      tAns = R;
    } else if (dif1 == ans && cost1 < w)
    {
      w = cost1;
      tAns = R;
    }
    
    return { ans, w, tAns };
  };

  for (int i = 0; i < n; i++)
  {
    ld A = prMax[i];
    ld B = sfMax[i];
    ld C = prMin[i];
    ld D = sfMin[i];
  
    //cout << A << " " << B << " " << C << " " << D << '\n';

    vector<ld> ans = { (ld)prMax[i], (ld)sfSum[i], 1.0 };
    
    //ld tAns = 1.0;
    //ld ans = prMax[i];
    //ld w = sfSum[i];
    // AC

    {
      ld L = C / D;
      ld R = A / B;
      if (L <= R)
      {
        auto res = check(i, L, R);
        ans = min(ans, res);
      }
    }
  
    // AD

    {
      ld L = 0;
      ld R = min(A / B, C / D);
      //cout << L << " " << R << '\n';
      if (L <= R)
      {
        auto res = check(i, L, R);
        //for (auto u : res)
        // cout << u << " ";
        //cout << '\n';
        ans = min(ans, res);
      }
    }

    // BC

    {
      ld L = max(C / D, A / B);
      ld R = 1;
      if (L <= R)
      {
        auto res = check(i, L, R);
        ans = min(ans, res);
      }
    }

    // BD 

    // AD

    {
      ld L = A / B;
      ld R = C / D;
      if (L <= R)
      {
        auto res = check(i, L, R);
        ans = min(ans, res);
      }
    }

    cout << (ld)1 - ans[2] << " ";
  }
  cout << '\n';
}

signed main() {
  cin.tie(nullptr)->ios::sync_with_stdio(false);
  cout << fixed << setprecision(10);
  int tests = 1;
  //cin >> tests
  for (int test = 1; test <= tests; ++test) {
    cerr << "_______Test # " << test << "_______:\n";
    solve();
    cerr << '\n';
  }
}