#include <iostream>
#include <string>
#include <map>
#include <vector>
#include <bitset>
using namespace std;
using ll = long long;

const int ALPHA = 26;
const ll MOD0 = 1000000007;
const ll MOD1 = 1000000009;

ll get_hash(string s, bitset<ALPHA> bs) {
    ll pw = ALPHA + 1;
    ll ans = 0;
    for (auto c : s) {
        if (bs[c - 'a']) {
            ans = (ans + pw * ll(c - 'a' + 1)) % MOD0;
        }
        pw = (pw * (ALPHA + 1)) % MOD0;
    }
    return ans;
}

bool dfs(vector<string> v, bitset<ALPHA> bs0) {
    if (v.size() == 1)
        return true;
    bitset<ALPHA> nbs = (1 << ALPHA) - 1;
    int n = v.size();
    for (int i = 0; i < n; ++i) {
        bitset<ALPHA> nnbs;
        for (auto x : v[i])
            nnbs[x - 'a'] = 1;
        nbs &= nnbs;
    }
    if (nbs == bs0) {
        return false;
    }
    map<ll, vector<string>> mp;
    for (int i = 0; i < n; ++i) {
        mp[get_hash(v[i], nbs)].push_back(v[i]);
    }
    for (auto [h, v0] : mp) {
        if (!dfs(v0, nbs))
            return false;
    }
    return true;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, l;
    cin >> l >> n;
    vector<string> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    if (dfs(v, 0)) {
        cout << "YES" << endl;
    } else {
        cout << "NO" << endl;
    }
}
