#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#include <tuple>
#include <deque>
#include <iomanip>
#define ll long long
using namespace std;

const int MOD = 1e9 + 7;
const int BASE = 29;

int code(char c) {
	if (c == '_')
		return 28;
	else
		return c - 'a' + 1;
}

int s_hash(string s, set<char> allowed) {
	int res = 0;
	for (int i = 0; i < s.length(); ++i) {
		char c = s[i];
		if (allowed.count(c) == 0)
			c = '_';
		res = ((ll)res * BASE) % MOD + (code(c));
	}

	return res;
}

set<char> letters(vector<string>& words) {
	set<char> res;
	for (char c = 'a'; c <= 'z'; ++c)
		res.insert(c);

	for (auto w : words) {
		set<char> cur;
		for (char c : w)
			cur.insert(c);
		set<char> nres;
		for (auto c : res)
			if (cur.count(c) == 1)
				nres.insert(c);
		res = nres;
	}
	return res;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);
	map<int, vector<string>> dict;

	int l, n;
	cin >> l >> n;
	dict[0] = vector<string>();
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		dict[0].push_back(s);
	}

	bool flag = true;
	while (dict.size() < n) {
		map<int, vector<string>> dc = dict;
		for (auto p : dc) {
			auto h = p.first;
			auto words = p.second;
			if (words.size() > 1) {
				auto let = letters(words);
				int new_cnt = 0;
				for (auto w : words) {
					auto sh = s_hash(w, let);
					if (dict.count(sh) == 0) {
						dict[sh] = vector<string>();
						new_cnt++;
					}
					dict[sh].push_back(w);
				}
				if (new_cnt == 1) {
					flag = false;
					break;
				}
				dict.erase(h);
			}
		}
		if (!flag)
			break;
	}

	if (flag)
		cout << "YES\n";
	else
		cout << "NO\n";
}
