#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <math.h>
#include <climits>
#include <queue>
#include <algorithm>
#include <assert.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const int INF = INT_MAX;

vector <int> a, b;

int solve(){
    set<pair<int, int>> empty;
    set<pair<int, int>> students;
    int n = a.size();
    int ans = 0;
    for (int i = 0; i < n; ++i){
        if (a[i] > b[i]){
            students.insert({-i, a[i] - b[i]});
        } else if (b[i] > a[i]){
            empty.insert({-i, b[i] - a[i]});
        }
        while (!students.empty() && !empty.empty()) {
            int ind_stud = (*students.begin()).first;
            int count_stud = (*students.begin()).second;
            int ind_room = (*empty.begin()).first;
            int count_room = (*empty.begin()).second;
            ans = max(ans, abs(ind_room - ind_stud));
            if (count_stud > count_room){
                empty.erase(*empty.begin());
                students.erase(*students.begin());
                students.insert({ind_stud, count_stud - count_room});
            } else if (count_room > count_stud){
                students.erase(*students.begin());
                empty.erase(*empty.begin());
                empty.insert({ind_room, count_room - count_stud});
            } else{
                students.erase(*students.begin());
                empty.erase(*empty.begin());
            }
        }
    }
    return ans;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(18);
    #ifdef HOME_DIDUK001
    freopen("in", "r", stdin);
    freopen("out", "w", stdout);
    #endif

    int n;
    cin >> n;
    
    a.resize(n);
    b.resize(n);
    ll s_a = 0, s_b = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        s_a += a[i];
    }

    for (int i = 0; i < n; i++) {
        cin >> b[i];
        s_b += b[i];
    }
    if (s_b < s_a){
        cout << -1;
        return 0;
    }
    int ans = 0;
    ans = solve();
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());
    cout << max(ans, solve());
}