#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef long long ll;

bool ok(int n, int m, vector<ll>& a, vector<ll>& b, vector<ll>& prefA, vector<ll>& prefB) {
	for (int i = 0; i < n; i++) {
		ll sumB = prefB[min(n, i + 1 + m)] - prefB[max(0, i - m)];
		ll sumA = a[i];
		if (i < n - 1) {
			sumA += prefA[(min(n, i + 1 + m))] - prefA[i+1];
		}
		if (i > 0) {
			sumA += prefA[i] - prefA[(max(0, i - m))];
		}
		if (sumA > sumB) {
			return false;
		}
	}
	return true;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);


	int n;
	cin >> n;
	vector<ll> a(n);
	vector<ll> b(n);
	for (auto& el : a) {
		cin >> el;
	}
	for (auto& el : b) {
		cin >> el;
	}

	bool flag0 = true;
	ll sumA = 0;
	vector<ll> prefA(n + 1, 0LL), prefB(n + 1, 0LL);
	for (int i = 0; i < n; i++) {
		prefB[i + 1] = prefB[i] + b[i];
		prefA[i + 1] = prefA[i] + min(b[i], a[i]);
		sumA += a[i];
		if (a[i] > b[i]) {
			flag0 = false;
		}
	}
	if (flag0) {
		cout << "0\n";
		return 0;
	}
	if (sumA > prefB.back()) {
		cout << "-1\n";
		return 0;
	}
	
	int l = 0;
	int r = n;
	while (r - l > 1) {
		int m = (l + r) / 2;
		if (ok(n, m, a, b, prefA, prefB)) {
			r = m;
		}
		else {
			l = m;
		}
	}
	cout << r << '\n';
	return 0;
}

/*
4
6 14 70 1
70 3 16 5

*/