#define _USE_MATH_DEFINES

#include <iostream>
#include <iomanip>

#include <cmath>
#include <algorithm>

#include <vector>
#include <string>
#include <map>
#include <set>

using namespace std;

typedef long long ll;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((ll)(x).size())

int main() {
    ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

    int n; cin >> n;
    vector<int> a(n), b(n);
    ll sum1 = 0, sum2 = 0;
    for (auto& c : a) {
        cin >> c;
        sum1 += c;
    }
    for (auto& c : b) {
        cin >> c;
        sum2 += c;
    }

    if (sum1 > sum2) {
        cout << -1;
        return 0;
    }

    int l = -1, r = n - 1;
    while (r - l > 1) {
        int m = (l + r) / 2;

        vector<int> cur_a = a;
        for (int i = 0; i < n; i++) {
            while (cur_a[i] > 0) {
                bool flag = false;

                for (int j = max(0, i - m); j < i; j++) {
                    if (cur_a[j] < b[j]) {
                        cur_a[j]++;
                        flag = true;
                        break;
                    }
                }

                if (flag) {
                    cur_a[i]--;
                }
                else {
                    break;
                }
            }
        }

        for (int i = n - 1; i >= 0; i--) {
            while (cur_a[i] > 0) {
                bool flag = false;

                for (int j = i + 1; j < min(n, i + m + 1); j++) {
                    if (cur_a[j] < b[j]) {
                        cur_a[j]++;
                        flag = true;
                        break;
                    }
                }

                if (flag) {
                    cur_a[i]--;
                }
                else {
                    break;
                }
            }
        }

        bool is_bad = false;
        for (int i = 0; i < n; i++) {
            if (cur_a[i] > b[i]) {
                is_bad = true;
            }
        }

        if (is_bad)
            l = m;
        else
            r = m;
    }

    cout << r;
    return 0;
}