#define _USE_MATH_DEFINES

#include <iostream>
#include <iomanip>

#include <cmath>
#include <algorithm>

#include <vector>
#include <string>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef double ld;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((ll)(x).size())

const ld eps = 1e-10;

ld solve(ld min1, ld max1, ld min2, ld max2) {
    ld l = 0, r = 1.0 + eps;
    for (int i = 0; i < 500; i++) {
        ld m1 = l + (r - l + eps) / 3, m2 = l + 2 * (r - l + eps) / 3;

        ld curmin1 = min2 * (1 - m1), curmax1 = max2 * (1 - m1);
        ld curmin2 = min2 * (1 - m2), curmax2 = max2 * (1 - m2);

        ld ans1 = max({ max1, curmax1, min1, curmin1 }) - min({ max1, curmax1, min1, curmin1 });
        ld ans2 = max({ max1, curmax2, min1, curmin2 }) - min({ max1, curmax2, min1, curmin2 });

        if (ans1 - ans2 < -eps)
            r = m2;
        else
            l = m1;
    }
    return l;
}

int main() {
    ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);


    // E


    int n;
    cin >> n;
    vector<ld> a(n);
    vector<pair<ld, ld>> pref(n + 1), suf(n + 1);
    pref[0] = { 2.0 * 1e9, -2.0 * 1e9 };
    suf[n] = { 2.0 * 1e9, -2.0 * 1e9 };
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pref[i + 1].first = min(pref[i].first, a[i]);
        pref[i + 1].second = max(pref[i].second, a[i]);
    }
    for (int i = n - 1; i >= 0; --i) {
        suf[i].first = min(suf[i + 1].first, a[i]);
        suf[i].second = max(suf[i + 1].second, a[i]);
    }
    cout << setprecision(10) << fixed << 1.0 << ' ';
    for (int i = 1; i < n; ++i) {
        ld min1 = pref[i].first, min2 = suf[i].first;
        ld max1 = pref[i].second, max2 = suf[i].second;
        cout << solve(min1, max1, min2, max2) << ' ';
    }

    return 0;
}