#define _USE_MATH_DEFINES

#include <iostream>
#include <iomanip>

#include <cmath>
#include <algorithm>

#include <vector>
#include <string>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((ll)(x).size())

const ld eps = 1e-8;

struct f {
	ld a, b, c;
	f() = default;
	f(ld a, ld b, ld c) :a(a), b(b), c(c) {}

	ld get(ld x) {
		return a * x * x + b * x + c;
	}
	ld good(ld x, ld y) {
		if (a > 0)
			return y - get(x) > eps;
		return y - get(x) < -eps;
	}
};

vector<f> a;

int get(ld x, ld y) {
	int cnt = 0;
	for (auto c : a) {
		if (c.good(x, y)) {
			cnt++;
		}
	}

	return cnt;
}

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

	int n; cin >> n;
	a.resize(n);
	for (auto& c : a) {
		cin >> c.a >> c.b >> c.c;
	}

	ld add = 2 * eps;
	if (a[0].a < 0)
		add *= -1;

	ld l = -2.5e4, r = 2.5e4;
	for(int i = 0;i < 500; i++){
		ld len = r - l + eps;
		ld m1 = l + len / 3, m2 = l + len * 2 / 3;

		if (get(m1, a[0].get(m1) + add) < get(m2, a[0].get(m2) + add)) {
			l = m1;
		}
		else {
			r = m2;
		}
	}

	cout << setprecision(6) << fixed << l << ' ' << a[0].get(l) + add;

	return 0;
}