#define _USE_MATH_DEFINES

#include <iostream>
#include <iomanip>

#include <cmath>
#include <algorithm>

#include <vector>
#include <string>
#include <map>
#include <set>

#include <numeric>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((ll)(x).size())

struct aaa {
	string mask, s;
	set<char> uni;
	aaa() :mask(""), s("") {}
	aaa(const string& _s) {
		s = _s;
		mask = "";
		for (int i = 0; i < s.size(); ++i) {
			mask += '#';
			uni.insert(s[i]);
		}
	}
	bool operator < (aaa& b) const {
		return mask < b.mask;
	}
};
vector<aaa> a;
bool comp(const int v1, const int v2) {
	return a[v1] < a[v2];
}
set<char> merge_s(const set<char> s1, const set<char>& s2) {
	set<char> ans;
	for (auto i : s1)
		if (s2.count(i))
			ans.insert(i);
	return ans;
}

bool solve(int l, int r, vector<int> &ord) {
	if (l + 1 == r)
		return true;
	set<char> u = a[ord[l]].uni;
	for (int i = l + 1; i < r; ++i) {
		u = merge_s(u, a[ord[i]].uni);
		if (u.empty())
			return false;
	}
	for (int i = l; i < r; ++i)
		for (int j = 0; j < a[ord[i]].s.size(); ++j)
			if (u.count(a[ord[i]].s[j]))
				a[ord[i]].mask[j] = a[ord[i]].s[j];
	sort(ord.begin() + l, ord.begin() + r, comp);
	int prev = l;
	for (int i = l + 1; i < r; ++i) {
		if (a[ord[prev]].mask != a[ord[i]].mask)
			if (!solve(prev, i, ord))
				return false;
			else
				prev = i;
	}
	if (prev == l)
		return false;
	else
		return solve(prev, r, ord);
}

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

	// I

	int n, m;
	cin >> m >> n;
	set<string> set_a;
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		set_a.insert(s);
	}
	for (auto &s : set_a)
		a.emplace_back(s);
	n = set_a.size();
	vector<int> ord(n);
	iota(ord.begin(), ord.end(), 0);

	if (solve(0, n, ord))
		cout << "YES";
	else
		cout << "NO";
	return 0;
}