#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pb push_back
#define ld long double

using ll = long long;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 5e5 + 5;
const int INF = 1e9 + 1;
const ll MOD = 1e9 + 7;

void mod(ll &x) {
    if (x < 0) {
        x += MOD;
    }
    if (x >= MOD) {
        x -= MOD;
    }
    if (x >= 0 && x < MOD) {
        return;
    }
    x %= MOD;
    if (x < 0) {
        x += MOD;
    }
}

ll add(ll a, ll b) {
    mod(a);
    mod(b);
    return a + b < MOD ? a + b : a + b - MOD;
}

ll sub(ll a, ll b) {
    mod(a);
    mod(b);
    return a - b < 0 ? a - b + MOD : a - b;
}

ll mul(ll a, ll b) {
    mod(a);
    mod(b);
    return a * b % MOD;
}

ll sum_mins(vector<int> a) {
    int n = a.size();
    vector<int> l(n, -1), r(n, n);
    vector<int> st;
    for (int i = 0; i < n; ++i) {
        while (!st.empty() && a[st.back()] >= a[i]) {
            r[st.back()] = i;
            st.pop_back();
        }
        st.push_back(i);
    }
    st.clear();
    for (int i = n - 1; i >= 0; --i) {
        while (!st.empty() && a[st.back()] > a[i]) {
            l[st.back()] = i;
            st.pop_back();
        }
        st.push_back(i);
    }
    ll res = 0;
    for (int i = 0; i < n; ++i) {
        if (a[i] != INF) {
            res = add(res, mul(i - l[i], mul(r[i] - i, a[i])));
        }
    }
    return res;
}

int n, k;
int a[N], b[N];
ll pref[N];
int rem[N];
int d[N];
map<int, vector<int>> by_rem;
ll ans;
int mn[2 * N];

int get_min(int l, int r) {
    l += n;
    r += n;
    int res = INF;
    while (l < r) {
        if (l & 1) {
            res = min(res, mn[l]);
            ++l;
        }
        if (r & 1) {
            --r;
            res = min(res, mn[r]);
        }
        l >>= 1;
        r >>= 1;
    }
    return res;
}

void gen() {
    n = rnd() % 100 + 1;
    k = rnd() % (INF - 1) + 1;
    for (int i = 0; i < n; ++i) {
        a[i] = rnd() % (INF - 1) + 1;
        b[i] = rnd() % (INF - 1) + 1;
        if (a[i] < b[i]) swap(a[i], b[i]);
    }
}

ll solve() {
    for (int i = 0; i < n; ++i) {
        pref[i + 1] = pref[i] + a[i];
        d[i] = a[i] - b[i];
        if (d[i] % k == 0) {
            d[i] = INF;
        }
    }
    for (int i = 0; i <= n; ++i) {
        rem[i] = pref[i] % k;
    }
    ans = 0;
    by_rem.clear();
    {
        map<ll, int> cnt;
        map<ll, ll> sum;
        ll total_cnt = 0;
        ll total_sum = 0;
        for (int i = 0; i <= n; ++i) {
            ans = add(ans, sub(mul(total_cnt, pref[i]),total_sum));
            ans = sub(ans, sub(mul(cnt[rem[i]], pref[i]), sum[rem[i]]));
            ++total_cnt;
            total_sum = add(total_sum, pref[i]);
            ++cnt[rem[i]];
            sum[rem[i]] = add(sum[rem[i]], pref[i]);
        }
    }
    for (int i = 0; i < n; ++i) {
        mn[i + n] = d[i];
    }
    for (int i = n - 1; i > 0; --i) {
        mn[i] = min(mn[2 * i], mn[2 * i + 1]);
    }
    for (int i = 0; i <= n; ++i) {
        by_rem[rem[i]].push_back(i);
    }
    for (const auto &[_rem, inds] : by_rem) {
        int sz = inds.size();
        if (sz == 1) continue;
        for (int i = 0; i < sz; ++i) {
            ans = add(ans, mul(pref[inds[i]], i));
            ans = sub(ans, mul(pref[inds[i]], sz - i - 1));
        }
        vector<int> mns;
        for (int i = 0; i + 1 < sz; ++i) {
            mns.push_back(get_min(inds[i], inds[i + 1]));
        }
        int last = -1;
        for (int i = 0; i < sz - 1; ++i) {
            if (mns[i] != INF) {
                last = i;
            }
            ans = sub(ans, mul(pref[inds[i + 1]], i - last));
        }
        last = sz - 1;
        for (int i = sz - 2; i >= 0; --i) {
            if (mns[i] != INF) {
                last = i;
            }
            ans = add(ans, mul(pref[inds[i]], last - i));
        }
        ans = sub(ans, sum_mins(mns));
    }
    return ans;
}

ll slow() {
    ll anss = 0;
    for (int i = 0; i < n; ++i) {
        ll sum = 0;
        ll mn_d = INF;
        for (int j = i; j < n; ++j) {
            mn_d = min<ll>(mn_d, d[j]);
            sum = add(sum, a[j]);
            if (sum % k == 0) {
                if (mn_d < INF) {
                    anss = add(anss, sub(sum, mn_d));
                }
            } else {
                anss = add(anss, sum);
            }
        }
    }
    return anss;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    if (0) {
        int t = 10000;
        while (t--) {
            gen();
            ll ans1 = solve();
            ll ans2 = slow();
            cout << ans1 << " " << ans2 << endl;
            if (ans1 != ans2) {
                cout << n << " " << k << endl;
                for (int i = 0; i < n; ++i) {
                    cout << a[i] << " " << b[i] << endl;
                }
                cout << endl;
                return 0;
            }
        }
    } else {
        cin >> n >> k;
        for (int i = 0; i < n; ++i) {
            cin >> a[i] >> b[i];
            if (a[i] < b[i]) swap(a[i], b[i]);
        }
        cout << solve() << endl;
    }
    return 0;
}