#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
using namespace std;
#define int ll
#define f first
#define s second
#define vi vector<int>
#define pii pair<int, int>
#define pb push_back

const int mod = 1e9 + 7;

mt19937 rnd(time(0));

const int inf = 1e11;

struct node {
    node *l, *r;
    int x;
    int y;
    int s = 0;
    int sum = 0;
    int push = -1;
    int min = inf;
    node(int x) : l(0), r(0), x(x) {
        sum = x;
        min = x;
        s = 1;
        y = rnd();
    }
};

void push(node *v) {
    if (!v || v->push == -1)
        return;
    if (v->l) {
        v->l->x = v->push;
        v->l->push = v->push;
        v->l->min = v->push;
        v->l->sum = v->l->s * v->push;
    }
    if (v->r) {
        v->r->x = v->push;
        v->r->push = v->push;
        v->r->min = v->push;
        v->r->sum = v->r->s * v->push;
    }
    v->push = -1;
}

void upd(node *v) {
    if (!v)
        return;
    v->min = min({v->x, v->l ? v->l->min : int(inf), v->r ? v->r->min : int(inf)});
    v->sum = (v->l ? v->l->sum : 0) + (v->r ? v->r->sum : 0) + v->x;
    v->s = (v->l ? v->l->s : 0) + (v->r ? v->r->s : 0) + 1;
}

pair<node*, node*> split(node *v, int x) {
    if (!v)
        return {0, 0};
    push(v);
    if (v->x >= x) {
        auto p = split(v->r, x);
        v->r = p.f;
        upd(v);
        return {v, p.s};
    } else {
        auto p = split(v->l, x);
        v->l = p.s;
        upd(v);
        return {p.f, v};
    }
}

node* merge(node *a, node *b) {
    push(a);
    push(b);
    if (!a)
        return b;
    if (!b)
        return a;
    if (a->y > b->y) {
        a->r = merge(a->r, b);
        upd(a);
        return a;
    } else {
        b->l = merge(a, b->l);
        upd(b);
        return b;
    }
}

void dfs(node *v) {
    if (!v)
        return;
    push(v);
    dfs(v->l);
    cout << v->x << ' ';
    dfs(v->r);
}

void solve() {
    int n, k;
    cin >> n >> k;
    pii a[n];
    for (auto &i : a)
        cin >> i.f >> i.s;
    for (int i = 0; i < n; ++i) {
        if (a[i].f < a[i].s)
            swap(a[i].f, a[i].s);
    }
    int suf[n];
    for (int i = n - 1; i >= 0; --i) {
        suf[i] = a[i].f;
        if (i + 1 < n)
            suf[i] += suf[i + 1];
    }
    int sparse[n][20];
    for (int i = n - 1; i >= 0; --i) {
        sparse[i][0] = (a[i].f % k == a[i].s % k ? int(inf) : a[i].f - a[i].s);
        for (int j = 1; j < 20; ++j) {
            sparse[i][j] = min(sparse[i][j - 1], sparse[min(n - 1, i + (1 << j - 1))][j - 1]);
        }
    }
    int d = 0;
    int st[n + 5];
    for (int i = 0; i < n + 5; ++i) {
        while ((1 << d + 1) <= i)
            d++;
        st[i] = d;
    }
    auto get = [&] (int l, int r) {
        int d = st[r - l + 1];
        return min(sparse[l][d], sparse[r - (1 << d) + 1][d]);
    };
    map<int, vi> mp;
    map<int, node*> mp2;
    mp[0].pb(n);
    mp2[0] = new node(inf);
    int sum = 0;
    int ans = 0;
    for (int i = n - 1; i >= 0; --i) {
        int now = suf[i] % k;
        auto v = mp2[now];
        if (v == 0) {
            v = merge(new node(inf), v);
        } else {
            int x = get(i, mp[now].back() - 1);
            auto p = split(v, x);
            if (p.f) {
                p.f->push = x;
                p.f->x = p.f->push;
                p.f->min = p.f->push;
                p.f->sum = p.f->s * p.f->push;
            }

            v = merge(p.f, p.s);
            p = split(v, inf);
            if (p.s)
                ans -= p.s->sum;
            v = merge(p.f, p.s);
            v = merge(new node(inf), v);
        }
//        cout << suf[i] * (n - i) - sum << endl;
        ans += suf[i] % mod * (n - i) % mod - sum;
        mp2[now] = v;
        sum += suf[i];
        sum %= mod;
        mp[now].pb(i);
        ans = (ans % mod + mod) % mod;
    }
    cout << ans << endl;
}


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.precision(16);
    solve();
    return 0;
}