#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vsi = vector<set<ll>>;
using vmsi = vector<multiset<ll>>;
using ld = long double;
using vs = vector<string>;
using vb = vector<bool>;


#ifndef DEBUG
#define endl '\n'
#endif


template<typename T, typename V>
istream &operator>>(istream &is, pair<T, V> &p) {
    is >> p.first >> p.second;
    return is;
}


template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (auto &e: v) is >> e;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (auto &e: v) os << e << ' ';
    return os;
}

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(30);
    cout.setf(ios::fixed);

    solve();
}

// ----------------

ll m, n;

constexpr ld eps = 1e-8;

ld F(ld a, ld b, ld c, ld d) {
    return a * d + b + c;
}

ld F1(tuple<ld, ld, ld, ld> t) {
    auto[a, b, c, d] = t;
    return F(a, b, c, d);
}

ld bins1(ld a, ld b, ld d, ll t3) {
    ld c;
    if (abs(b - 1) < eps * 1e5)
        c = t3;
    else
        c = (a - 1) * (d - 1) / (b - 1) + 1;
    if (c > t3) return -1e18;
    return c;
}

tuple<ld, ld> bins2(ld a, ld b, ll t3, ll t4) {
    ld dl = 0, dr = t4;
    while (dr - dl > eps) {
        ld m1 = dl + (dr - dl) / 3 * 1;
        ld m2 = dl + (dr - dl) / 3 * 1;
        ld c1 = bins1(a, b, m1, t3);
        ld c2 = bins1(a, b, m2, t3);
        if (F(a, b, c1, m1) > F(a, b, c2, m2)) {
            dr = m2;
        } else {
            dl = m1;
        }
    }
    return {bins1(a, b, dl, t3), dl};
}

tuple<ld, ld, ld> bins3(ld a, ll t2, ll t3, ll t4) {
    ld bl = 0, br = t2;
    while (br - bl > eps) {
        ld m1 = bl + (br - bl) / 3 * 1;
        ld m2 = bl + (br - bl) / 3 * 1;
        auto[c1, d1] = bins2(a, m1, t3, t4);
        auto[c2, d2] = bins2(a, m2, t3, t4);
        if (F(a, m1, c1, d1) > F(a, m2, c2, d2)) {
            br = m2;
        } else {
            bl = m1;
        }
    }
    auto[c, d] = bins2(a, bl, t3, t4);
    return {bl, c, d};
}

tuple<ld, ld, ld, ld> bins4(ll t1, ll t2, ll t3, ll t4) {
    ld al = 0, ar = t1;
    while (ar - al > eps) {
        ld m1 = al + (ar - al) / 3 * 1;
        ld m2 = al + (ar - al) / 3 * 1;
        auto[b1, c1, d1] = bins3(m1, t2, t3, t4);
        auto[b2, c2, d2] = bins3(m2, t2, t3, t4);
        if (F(m1, b1, c1, d1) > F(m2, b2, c2, d2)) {
            ar = m2;
        } else {
            al = m1;
        }
    }
    auto[b, c, d]=bins3(al, t2, t3, t4);
    return {al, b, c, d};
}

void solve() {
    ll t1, t2, t3, t4;
    cin >> t1 >> t2 >> t3 >> t4;
    vi ans;
    ld mx = 0;
    tuple<ld, ld, ld, ld> ans2;

    ld res;
    res = F1(bins4(t1, t2, t3, t4));
    if (res > mx) {
        ans = {1, 2, 3, 4};
        ans2 = bins4(t1, t2, t3, t4);
        mx = res;
    }
    res = F1(bins4(t1, t2, t4, t3));
    if (res > mx) {
        ans = {1, 2, 4, 3};
        ans2 = bins4(t1, t2, t4, t3);
        mx = res;
    }
    res = F1(bins4(t1, t3, t2, t4));
    if (res > mx) {
        ans = {1, 3, 2, 4};
        ans2 = bins4(t1, t3, t2, t4);
        mx = res;
    }
    res = F1(bins4(t1, t3, t4, t2));
    if (res > mx) {
        ans = {1, 3, 4, 2};
        ans2 = bins4(t1, t3, t4, t2);
        mx = res;
    }
    res = F1(bins4(t1, t4, t2, t3));
    if (res > mx) {
        ans = {1, 4, 2, 3};
        ans2 = bins4(t1, t4, t2, t3);
        mx = res;
    }
    res = F1(bins4(t1, t4, t3, t2));
    if (res > mx) {
        ans = {1, 4, 3, 2};
        ans2 = bins4(t1, t4, t3, t2);
        mx = res;
    }
    cout << ans << endl;
    auto[a, b, c, d]=ans2;
    cout << a << ' ' << b << ' ' << c << ' ' << d << endl;
}
