#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const int N = 5e5 + 20;

int n, k;
vector<int> a, b;
ll result, pref[N];

int t[4 * N];

void build(int v, int tl, int tr){
      if(tl == tr){
            t[v] = tl;
            return;
      }
      int tm = (tl + tr) / 2;
      build(v * 2, tl, tm);
      build(v * 2 + 1, tm + 1, tr);
      int x = t[v * 2], y = t[v * 2 + 1];
      if(a[x] - b[x] > a[y] - b[y])
            t[v] = y;
      else
            t[v] = x;
}

int get(int v, int tl, int tr, int l, int r){
      if(l > r)
            return -1;
      if(tl == l && tr == r)
            return t[v];
      int tm = (tl + tr) / 2;
      int x = get(v * 2, tl, tm, l, min(r, tm));
      int y = get(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r);
      if(x == -1)
            return y;
      if(y == -1)
            return x;
      if(a[x] - b[x] > a[y] - b[y])
            return y;
      return x;
}

unordered_map<int, int> qc[4 * N], wc[4 * N];
unordered_map<int, ll> qs[4 * N], wsm[4 * N];

void build2(int v, int tl, int tr){ // right
      for(int i = tl; i <= tr; i ++){
            qc[v][pref[i] % k] ++;
            qs[v][pref[i] % k] += pref[i];
      }
      if(tl == tr)
            return;
      int tm = (tl + tr) / 2;
      build2(v * 2, tl, tm);
      build2(v * 2 + 1, tm + 1, tr);
}

pair<ll, int> get2(int v, int tl, int tr, int l, int r, int x){
      if(l > r)
            return make_pair(0, 0);
      if(tl == l && tr == r)
            return {qs[v][x], qc[v][x]};
      int tm = (tl + tr) / 2;
      auto A = get2(v * 2, tl, tm, l, min(r, tm), x);
      auto B = get2(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r, x);
      return make_pair(A.first + B.first, A.second + B.second);
}

void build3(int v, int tl, int tr){ // left
      for(int i = tl; i <= tr; i ++){
            wc[v][(i == 0 ? 0 : pref[i - 1]) % k] ++;
            wsm[v][(i == 0 ? 0 : pref[i - 1]) % k] += (i == 0 ? 0 : pref[i - 1]);
      }
      if(tl == tr)
            return;
      int tm = (tl + tr) / 2;
      build3(v * 2, tl, tm);
      build3(v * 2 + 1, tm + 1, tr);
}

pair<ll, int> get3(int v, int tl, int tr, int l, int r, int x){
      if(l > r)
            return make_pair(0, 0);
      if(tl == l && tr == r)
            return {wsm[v][x], wc[v][x]};
      int tm = (tl + tr) / 2;
      auto A = get3(v * 2, tl, tm, l, min(r, tm), x);
      auto B = get3(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r, x);
      return make_pair(A.first + B.first, A.second + B.second);
}


void solve(int l, int r){
      if(l > r)
            return;
      // segments [l...p, p...r]
      int p = get(1, 0, n - 1, l, r);
      if(a[p] == b[p])
            return;
      if(p - l <= r - p){
            for(int i = l; i <= p; i ++){
                  auto w = get2(1, 0, n - 1, p, r, (i == 0 ? 0 : pref[i - 1] % k)); // pair (sum, cnt)
                  result += w.first - (i == 0 ? 0 : pref[i - 1]) * w.second + w.second * (b[p] - a[p]);
            }
      }else{
            for(int i = p; i <= r; i ++){
                  auto w = get3(1, 0, n - 1, l, p, pref[i] % k); // pair (sum, cnt)
                  result += pref[i] * w.second - w.first + w.second * (b[p] - a[p]);
            }
      }
      solve(l, p - 1);
      solve(p + 1, r);
}

int main(){
      ios_base :: sync_with_stdio(0);
      cin.tie(0); cout.tie(0);
      cin >> n >> k;
      a.resize(n), b.resize(n);
      for(int i = 0; i < n; i ++){
            cin >> a[i] >> b[i];
            if(a[i] < b[i])
                  swap(a[i], b[i]);
      }
      ll all_p = 0;
      map<int, pair<int, ll>> sum;
//      vector<pair<int, ll>> sum(k);
      sum[0] = {1, 0};
      for(int i = 0; i < n; i ++){ // sum all segments without inverting with % k != 0
            pref[i] = (i > 0 ? pref[i - 1] : 0) + a[i];
            result += pref[i] * (i + 1);
            result -= all_p;
            result -= (pref[i] * sum[pref[i] % k].first - sum[pref[i] % k].second);
            sum[pref[i] % k].first ++;
            sum[pref[i] % k].second += pref[i];
            all_p += pref[i];
      }
      build(1, 0, n - 1);
      build2(1, 0, n - 1);
      build3(1, 0, n - 1);
      solve(0, n - 1);
      cout << result;
}
