#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
constexpr ld EPS = 1e-9;

template<class T>
using V = vector<T>;
template<class T>
using VV = V<V<T>>;

using VLL = V<ll>;
using VVLL = VV<ll>;
using VB = V<char>;
using VI = V<int>;

constexpr ll INF = 1e9;

#define FOR(i, n) for(ll i = 0; i < n; ++i)
#define ALL(a) begin(a), end(a)

constexpr ll MOD = 998244353;

ll qpow(ll a, ll b)
{
    ll r = 1;
    while(b)
    {
        if(b % 2 == 1)
            r = r * a % MOD;

        b /= 2;
        a = a * a % MOD;
    }

    return r;
}

ll inv(ll x)
{
    return qpow(x, MOD - 2);
}

pair<ld, V<ld>> f(VLL v)
{
    ld x = v[0], a = v[1], b = v[2], y = v[3];
    ll C = a * b - a - b;

    ld ans = -INF;
    ld xb = 0, yb = 0;

    auto r = [&](ld xp)
    {
        if(abs(x - 1) <= EPS)
            return;

        ld yp = (C + xp) / (xp - 1);
        if(xp <= x && yp <= y)
        {
            if(xp * yp >= ans)
            {
                xb = xp;
                yb = yp;
                ans = xp * yp;
            }
        }
    };

    r(x);

    return {ans + a + b, {xb, a, b, yb}};
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cout << setprecision(12);

    VLL a(4);
    for(auto& i : a)
        cin >> i;

    VLL ind(4);
    iota(ALL(ind), 0LL);

    pair<ld, pair<VLL, V<ld>>> ans;
    ans.first = -INF;

    do
    {
        VLL b(4);
        FOR(i, 4)
            b[i] = a[ind[i]];

        auto r = f(b);
        if(r.first > ans.first)
        {
            ans.first = r.first;
            ans.second.first = ind;
            ans.second.second = r.second;
        }
    } while(next_permutation(ALL(ind)));

    for(auto i : ans.second.first)
        cout << i + 1 << " ";
    cout << "\n";
    for(auto i : ans.second.second)
        cout << i << " ";
    cout << "\n";
}
