// #pragma GCC optimize("O3,fast-math,unroll-loops")
#pragma GCC target("avx2")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

namespace x = __gnu_pbds;
template <typename T>
using ordered_set = x::tree<T, x::null_type, less<T>, x::rb_tree_tag, x::tree_order_statistics_node_update>;

template <typename T>
using normal_queue = priority_queue<T, vector<T>, greater<T>>;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
using ll = long long;
using ld = long double;

const int N = 2e5 + 10;
const ld INF = 1e30, EPS = 1e-7;

struct Parabola {
	ld a, b, c;
};

vector<Parabola> up, down;

pair<ld, ld> intersect(const Parabola &p, ld y) {
	auto [a, b, c] = p;
	ld d = sqrt(max<ld>(0, b * b - 4 * a * (c - y)));
	if (a > 0) {
		return {(-b - d) / (2 * a), (-b + d) / (2 * a)};
	} else {
		return {(-b + d) / (2 * a), (-b - d) / (2 * a)};
	}
}

pair<ld, int> evs[N];

pair<ld, ld> do_scanpoint(const vector<Parabola> &ps, ld y) {
	if (sz(ps) == 0) {
		return {-INF, +INF};
	}
	// vector<pair<ld, int>> evs;
	int ev_len = 0;
	for (auto p : ps) {
		auto [lef, rig] = intersect(p, y);
		evs[ev_len++] = {lef - EPS, 0};
		evs[ev_len++] = {rig + EPS, 1};
	}
	sort(evs, evs + ev_len);
	int balance = 0;
	pair<ld, ld> where = {+INF, -INF};
	// for (auto [x, t] : evs) {
	for (int i = 0; i < ev_len; ++i) {
		auto [x, t] = evs[i];
		if (balance == sz(ps)) {
			where.x = min(where.x, x);
			where.y = max(where.y, x);
		}
		if (t == 0) {
			++balance;
		} else {
			--balance;
		}
		if (balance == sz(ps)) {
			where.x = min(where.x, x);
			where.y = max(where.y, x);
		}
	}
	return where;
}

ld find_dst(ld y, pair<ld, ld> u, pair<ld, ld> d) {
	if (max(u.x, d.x) < min(u.y, d.y)) {
		cout << setprecision(10) << fixed << (min(u.y, d.y) + max(u.x, d.x)) / 2 << " " << y;
#ifdef DEBUG
		cout << endl << clock() << endl;
#endif
		exit(0);
	} else {
		return max(u.x, d.x) - min(u.y, d.y);
	}
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	int n;
	cin >> n;
	ld ymin = -INF, ymax = +INF;
	for (int i = 0; i < n; ++i) {
		ll araw, braw, craw;
		cin >> araw >> braw >> craw;
		ld a = araw, b = braw, c = craw;
		ld d = b * b - 4 * a * c;
		ld yc = -d / (4 * a);
		if (araw > 0) {
			up.push_back({a, b, c});
			ymin = max(ymin, yc);
		} else {
			down.push_back({a, b, c});
			ymax = min(ymax, yc);
		}
	}
	if (ymax == +INF) {
		ymax = 1e10;
	}
	if (ymin == +INF) {
		ymin = -1e10;
	}
	ld lef = ymin, rig = ymax;
	for (int iter = 0; ; ++iter) {
		ld mid1 = (2 * lef + rig) / 3, mid2 = (lef + 2 * rig) / 3;
		auto ans1up = do_scanpoint(up, mid1);
		auto ans1down = do_scanpoint(down, mid1);
		auto ans2up = do_scanpoint(up, mid2);
		auto ans2down = do_scanpoint(down, mid2);
		if (ans2down.x == +INF) {
			rig = mid2;
		} else if (ans1up.x == +INF) {
			lef = mid1;
		} else {
			assert(ans1down.x != +INF && ans2up.x != +INF);
			ld dst1 = find_dst(mid1, ans1up, ans1down);
			ld dst2 = find_dst(mid2, ans2up, ans2down);
			if (dst1 < dst2) {
				rig = mid2;
			} else {
				lef = mid1;
			}
		}
	}
	// cout << "not found" << endl;
}