#include<bits/stdc++.h>
#define f first
#define s second
#define fi first
#define se second
#define _ << ' '  <<

typedef long long ll;

using namespace std;

const int N = 5e5 + 5, LOG = 20, inf = 1e9 + 10;

const int MOD = 1e9 + 7;

int add(int x, int y) {
    return x + y >= MOD ? x + y - MOD : x + y;
}

int sub(int x, int y) {
    return x - y < 0 ? x - y + MOD : x - y;
}

int mul(int x, int y) {
    return 1ll * x * y % MOD;
}

int n, k, a[N], b[N], d[N];
ll pref[N];

int lenfor[N];
int sp[LOG][N];

void build() {
    for (int i = 2; i <= n; ++i) {
        lenfor[i] = lenfor[i >> 1] + 1;
    }
    for (int j = 0; j < LOG; ++j) {
        for (int i = 0; i <= n; ++i) {
            sp[j][i] = inf;
        }
    }
    for (int j = 0; j < LOG; ++j) {
        for (int i = 1; i + (1 << j) - 1 <= n; ++i) {
            if (!j) {
                sp[j][i] = d[i];
            } else {
                sp[j][i] = min(sp[j - 1][i], sp[j - 1][i + (1 << (j - 1))]);
            }
        }
    }
}

int get_dmin(int L, int R) {
    int len = lenfor[R - L + 1];
    return min(sp[len][L], sp[len][R - (1 << len) + 1]);
}

int sum[4 * N], value[4 * N];

void upd(int v, int tl, int tr, int val) {
    value[v] = val;
    sum[v] = mul(value[v], tr - tl);
}

void push(int v, int tl, int tr) {
    if (!value[v]) {
        return;
    }
    int tm = (tl + tr) / 2;
    upd(v * 2 + 1, tl, tm, value[v]);
    upd(v * 2 + 2, tm, tr, value[v]);
    value[v] = 0;
}

void update(int v, int tl, int tr, int L, int R, int val) {
    if (tl >= R || L >= tr) {
        return;
    }
    if (L <= tl && tr <= R) {
        upd(v, tl, tr, val);
        return;
    }
    push(v, tl, tr);
    int tm = (tl + tr) / 2;
    update(v * 2 + 1, tl, tm, L, R, val);
    update(v * 2 + 2, tm, tr, L, R, val);
    sum[v] = add(sum[v * 2 + 1], sum[v * 2 + 2]);
}

void build(int v, int tl, int tr) {
    if (tl + 1 == tr) {
        sum[v] = 0;
        value[v] = 0;
        return;
    }
    int tm = (tl + tr) / 2;
    build(v * 2 + 1, tl, tm);
    build(v * 2 + 2, tm, tr);
}

int get(int v, int tl, int tr, int L, int R) {
    if (tl >= R || L >= tr) {
        return 0;
    }
    if (L <= tl && tr <= R) {
        return sum[v];
    }
    push(v, tl, tr);
    int tm = (tl + tr) / 2;
    return add(get(v * 2 + 1, tl, tm, L, R), get(v * 2 + 2, tm, tr, L, R));
}

int solve(vector<int> &pos) {
    int ans = 0, m = (int) pos.size();
    build(0, 0, m);
    int sum_bad = 0, uk = 0;
    for (int i = 1; i < m; ++i) {
        int mn = get_dmin(pos[i - 1] + 1, pos[i]);
        if (mn != inf) {
            uk = i;
            sum_bad = 0;
            int lef = -1, rig = i - 1;
            while (lef + 1 < rig) {
                int mid = (lef + rig) / 2;
                if (get_dmin(pos[mid] + 1, pos[i]) < mn) {
                    lef = mid;
                } else {
                    rig = mid;
                }
            }
            update(0, 0, m, rig, i, mn);
        } else {
            sum_bad = add(sum_bad, pref[pos[i - 1]] % MOD);
        }
        ans = add(ans, get(0, 0, m, 0, uk));
        ans = add(ans, sub(mul(i - uk, pref[pos[i]] % MOD), sum_bad));
    }
    return ans;
}

vector<int> pos[N];

void read() {
    cin >> n >> k;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i] >> b[i];
        if (a[i] < b[i]) {
            swap(a[i], b[i]);
        }
    }
}

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int randint(int L, int R) {
    return L + rnd() % (R - L + 1);
}

void gen() {
    n = randint(1, 100);
    k = randint(1, 10000);
    for (int i = 1; i <= n; ++i) {
        a[i] = randint(1, 30000);
        b[i] = randint(1, 30000);
        if (a[i] < b[i]) {
            swap(a[i], b[i]);
        }
    }
}

int slow() {
    int ans = 0;
    for (int L = 1; L <= n; ++L) {
        for (int R = L; R <= n; ++R) {
            if ((pref[R] - pref[L - 1]) % k != 0) {
                ans = add(ans, (pref[R] - pref[L - 1]) % MOD);
            } else {
                int mn = inf;
                for (int j = L; j <= R; ++j) {
                    mn = min(mn, d[j]);
                }
                if (mn != inf) {
                    ans = add(ans, (pref[R] - pref[L - 1] - mn) % MOD);
                }
            }
        }
    }
    return ans;
}

int solve() {
    vector<int> diff;
    for (int i = 1; i <= n; ++i) {
        d[i] = a[i] - b[i];
        if (d[i] % k == 0) {
            d[i] = inf;
        }
        pref[i] = pref[i - 1] + a[i];
        diff.emplace_back(pref[i] % k);
    }
    int ans = 0;
    for (int i = 1; i <= n; ++i) {
        ans = add(ans, mul(i, mul(a[i], n - i + 1)));
    }
    build();
    diff.emplace_back(0);
    sort(diff.begin(), diff.end());
    diff.resize(unique(diff.begin(), diff.end()) - diff.begin());
    for (int v = 0; v < (int) diff.size(); ++v) {
        pos[v].clear();
    }
    for (int i = 0; i <= n; ++i) {
        int p = lower_bound(diff.begin(), diff.end(), pref[i] % k) - diff.begin();
        pos[p].emplace_back(i);
    }
    for (int v = 0; v < (int) diff.size(); ++v) {
        ans = sub(ans, solve(pos[v]));
    }
    return ans;
}

void compare() {
    int sol = solve(), sl = slow();
    if (sl != sol) {
        cout << "---\n";
        cout << n << " " << k << "\n";
        for (int i = 1; i <= n; ++i) {
            cout << a[i] << " " << b[i] << "\n";
        }
        cout << "slow = " << sl << ", sol = " << sol << "\n";
        exit(0);
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.in", "r", stdin);
#endif // LOCAC

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    read();
    cout << solve() << "\n";
    return 0;

    for (int t = 1; t <= 1000; ++t) {
        cout << t << endl;
        gen();
        compare();
    }

    return 0;
}

