#include "bits/stdc++.h"

using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define int ll
#define ff first
#define ss second
typedef pair<int, int> pii;
#define _ << ' ' <<
#define vec vector
#ifndef HOME
#define cerr if(0) cerr
#endif

const int INF = 1e18;

const ld EPS = 1e-5;

struct par {
    ld a, b, c;

    ld operator()(ld x) {
        return a * x * x + b * x + c;
    }
};

ld sqr(ld x) {
    ld l = 0, r = x;
    for (int i = 0; i < 123; ++i) {
        ld m = (r + l) / 2;
        if (m * m > x) {
            r = m;
        } else {
            l = m;
        }
    }
    return r;
}

pair<ld, ld> inter(par f, par s) {
    ld a = f.a - s.a;
    ld b = f.b - s.b;
    ld c = f.c - s.c;
    ld d = b * b - 4 * a * c;
    if (d < EPS) {
        return {-INF, INF};
    }
    ld sq = sqr(d);
    return {min((-b - sq) / (2 * a), (-b + sq) / (2 * a)), max((-b - sq) / (2 * a), (-b + sq) / (2 * a))};
}

bool check(par p, ld x, ld y) {
    if (p.a < 0) return p(x) > y;
    return p(x) < y;
}

void solve() {
    int n;
    cin >> n;

    int a, b, c;
    vector<par> v1, v2;
    for (int i = 0; i < n; ++i) {
        cin >> a >> b >> c;
        par p = {(ld)a, (ld)b, (ld)c};

        if (a > 0) v1.push_back(p);
        else v2.push_back(p);
    }

    cout << fixed << setprecision(9);
    if (v1.size() == 0) {
        ld mn = INF;
        for (auto it : v2) {
            mn = min(mn, it(0));
        }
        cout << 0 _ mn - 1;
        return;
    }
    if (v2.size() == 0) {
        ld mx = -INF;
        for (auto it : v1) {
            mx = min(mx, it(0));
        }
        cout << 0 _ mx + 1;
        return;
    }

    ld l = -INF, r = INF;
    int posl = 0;
    int posr = 0;
    for (int i = 0; i < v2.size(); ++i) {
        auto it = v2[i];
        auto [l1, r1] = inter(it, v1[0]);

        if (l < l1) {
            posl = i;
            l = l1;
        }
        if (r > r1) {
            r = r1;
            posr = i;
        }
    }
    for (auto it : v1) {
        {
            auto [l1, r1] = inter(it, v2[posl]);
            l = max(l, l1);
            r = min(r, r1);
        }
        auto [l1, r1] = inter(it, v2[posr]);
        l = max(l, l1);
        r = min(r, r1);
    }


//    if (l > r) swap(l, r);
    cerr << l _ r << endl;
    l += EPS;
    r -= EPS;
    ld yl = -INF;
    ld yr = -INF;
    for (auto it : v1) {
        yl = max(yl, it(l));
        yr = max(yr, it(r));
    }
//    for (auto it : v2) {
//        yl = min(yl, it(l));
//        yr = min(yr, it(r));
//    }

    yl += EPS;
    yr += EPS;

    bool fl = 1;
    for (auto it : v1) {
        if (!check(it, l, yl)) {
            fl = 0;
            break;
        }
    }
    for (auto it : v2) {
        if (!check(it, l, yl)) {
            fl = 0;
            break;
        }
    }

    if (fl) {
        cout << l _ yl;
        return;
    }

    fl = 1;
    for (auto it : v1) {
        if (!check(it, r, yr)) {
            fl = 0;
            break;
        }
    }
    for (auto it : v2) {
        if (!check(it, r, yr)) {
            fl = 0;
            break;
        }
    }
    if (fl) {
        cout << r _ yr;
        return;
    }
    exit(-1);
}

signed main() {
#ifdef HOME
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
        cout << '\n';
    }
}