#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>

#define ll long long

using namespace std;


vector<long double> vec, max_suf, max_pref, min_suf, min_pref;
int n;


long double razn(int i, long double m)
{
	long double h = max(max_pref[i - 1], max_suf[i] * m) - min(min_pref[i - 1], min_suf[i] * m);
	return h;
}

signed main() {

	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll s1 = 0, s2 = 0;
	cin >> n;
	vec.resize(n);
	max_suf.resize(n);
	max_pref.resize(n);
	min_suf.resize(n);
	min_pref.resize(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> vec[i];
	
		if (i > 0)
		{
			max_pref[i] = max(max_pref[i - 1], vec[i]);
			min_pref[i] = min(min_pref[i - 1], vec[i]);
		}
		else
		{
			max_pref[i] = vec[i];
			min_pref[i] = vec[i];
		}
	}
	max_suf[n - 1] = vec[n - 1];
	min_suf[n - 1] = vec[n - 1];
	for (int i = n - 2; i >= 0; --i)
	{
		max_suf[i] = max(max_suf[i + 1], vec[i]);
		min_suf[i] = min(min_suf[i + 1], vec[i]);
	}
	cout << "1.00\n";
	for (int i = 1; i < n; ++i)
	{
		long double L = 0, R = 1, m1, m2;
		for (int h = 0; h < 70; ++h)
		{
			m1 = (L + L + R) / 3;
			m2 = (L + R + R) / 3;
			if (razn(i, m1) > razn(i, m2))
			{
				L = m1;
			}
			else
			{
				R = m2;
			}
		}
		cout << setprecision(10) << 1.0 - L << "\n" ;
		
	
	}
}
