#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>
#include <numeric>

using namespace std;

typedef vector<int> vi;
typedef long long ll;
typedef long double ld;

int n;
vi a, b;

struct Event {
    int l;
    int r;
    int v;
};

bool comp(int x, int y) {
    return a[x] < a[y];
}

bool f(int d) {
    vector<Event> evs;
    for (int i = 0; i < n; i++) {
        evs.push_back({ max(0, i - d), min(n - 1, i + d), a[i] });
    }
    reverse(evs.begin(), evs.end());
    vi left = b;
    for (int i = 0; i < n; i++) {
        while (left[i] > 0 && evs.size() > 0 && evs.back().l <= i) {
            Event ev = evs.back();
            if (ev.r < i) return false;
            if (ev.v > left[i]) {
                evs.back().v -= left[i];
                left[i] = 0;
            }
            else {
                left[i] -= ev.v;
                evs.pop_back();
            }
        } 
    }
    if (evs.size() >= 1) return false;
    return true;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    vi inds(n);
    a = vi(n);
    b = vi(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> b[i];
    bool flag = true;
    ll free = 0, students = 0;
    for (int i = 0; i < n; i++) {
        free += b[i];
        students += a[i];
        if (b[i] < a[i]) flag = false;
    }
    if (flag) {
        cout << 0; 
        return 0 ;
    }
    if (free < students) {
        cout << -1;
        return 0;
    }
    iota(inds.begin(), inds.end(), 0);
    sort(inds.begin(), inds.end(), comp);
    int res = 0;
    int l = 0;
    int r = n+1;
    //f(2);
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (f(m)) {
            r = m;
        }
        else {
            l = m;
        }
    }
    cout << r;
}
