#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <fstream>
#include <iomanip>
#include <assert.h>
#include <numeric>
#include <algorithm>
#include<vector>
#include<queue>
#include<set>
#include<map>
#include<math.h>
#include<string>
#include<random>
#include<cmath>

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#define endl '\n'
#define all(v) v.begin(), v.end()
#define mp make_pair
#define pb push_back

const int N = 2e5 + 10;

struct P
{
	ld a, b, c;
	P() {}
	P(int x, int y, int z) :a(x), b(y), c(z) {}
	ld operator()(ld x)
	{
		return x * x * a + x * b + c;
	}
	ld v()
	{
		return -b / (2 * a);
	}
	pair<ld, ld> root()
	{
		return mp((-b - sqrtl(b * b - 4 * a * c)) / (2 * a),(-b + sqrtl(b * b - 4 * a * c)) / (2 * a));
	}
	friend P operator-=(P& a, P b)
	{
		a.a -= b.a;
		a.b -= b.b;
		a.c -= b.c;
		return a;
	}
	friend P operator-(P a, P b)
	{
		return a -= b;
	}
};

vector<P> p;

int f(ld y)
{
	for (P now : p)
	{
		if (now.a > 0 && now(now.v()) > y)
		{
			return 1;
		}
		if (now.a < 0 && now(now.v()) < y)
		{
			return -1;
		}
	}
	ld l = -1, r = -1;
	ld lp, rp;
	for (int i = 0; i < p.size(); i++)
	{
		P now = p[i];
		now.c -= y;
		pair<ld, ld>par = now.root();
		if (par.first > par.second)
			swap(par.first, par.second);
		if (l == -1 || lp > par.second)
		{
			lp = par.second;
			l = i;
		}
		if (r == -1 || rp < par.first)
		{
			rp = par.first;
			r = i;
		}
	}
	if (lp >= rp)
	{
		cout << fixed << setprecision(12) << (lp + rp) / 2 << " " << y;
		exit(0);
	}
	auto now = (p[l] - p[r]).root();
	if (p[l](now.first) > y)
	{
		return 1;
	}
	else
	{
		return -1;
	}
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		int a, b, c;
		cin >> a >> b >> c;
		p.push_back({ a,b,c });
	}
	ld L = -2e18, R = 2e18;
	while (true)
	{
		ld M = (L + R) / 2;
		if (f(M) == -1)
			R = M;
		else
			L = M;
	}
}