﻿
#include <algorithm>
#include <iostream>
#include <cmath>
#include <math.h>
#include <vector>
#include <queue>
#include <iomanip>
using namespace std;
const int N = 2e5;

#define int long long
const int q = 29;
const int Mod = 1e9 + 7;
vector <int> mac[N][q];
pair <int, int> hesh[N];
queue <pair <int, int>> qu;
int timer = 0;
int used[q];
vector <int> sames;
int st_qu[N];

int make_hesh(int x, int y)
{
    return (x * st_qu[y]) % Mod;
}
void hesh_make(int L, int R)
{
    for (int x : sames)
    {
        for (int i = L; i < R; i++)
        {
            int i1 = hesh[i].second;
            for (int y : mac[i1][x])
            {
                hesh[i].first += make_hesh(x+1, y);
                hesh[i].first %= Mod;
            }
            mac[i1][x].clear();
        }
    }
}

void find_same(int L,int R)
{
    sames.clear();
    for (int i = 0; i < q; i++)
    {
        used[i] = 0;
    }
    for (int j = 0; j < 26; j++)
    {
        for (int i1 = L; i1 < R; i1++)
        {
            int i = hesh[i1].second;
            if (mac[i][j].size() > 0)
            {
                used[j]++;
            }
        }
    }
    for (int i = 0; i < 26; i++)
    {
        if (used[i] == R - L)
        {
            sames.push_back(i);
        }
    }
    if (sames.size() == 0)
    {
        cout << "NO";
        exit(0);
    }
}

signed main()
{
    int a, b;
    cin >> a >> b;
    st_qu[0] = 1;
    for (int i = 1; i <= a; i++)
    {
        st_qu[i] = st_qu[i-1] * q;
        st_qu[i] %= Mod;
    }
    for (int i = 0; i < b; i++)
    {
        string s;
        cin >> s;
        for (int j = 0; j < a; j++)
        {
            mac[i][s[j]-'a'].push_back(j);
        }
        hesh[i].second = i;
    }
    qu.push({ 0, b });
    while (!qu.empty())
    {
        pair<int, int> x = qu.front();
        qu.pop();
        find_same(x.first,x.second);
        hesh_make(x.first, x.second);
        sort(hesh + x.first, hesh + x.second);
        int j = 0;
        for (int i = x.first; i < x.second; i++)
        {
            if (hesh[i].first != hesh[i + 1].first)
            {
                if((i - j) > 0)
                    qu.push({ j,i+1 });
                j = i+1;
            }
        }

    }  
    cout << "YES";
}