#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

#include <string>
#include <numeric>
#include <cmath>
#include <bitset>
#include <set>
#include <cfloat>
#include <iomanip>

using namespace  std;
#define int long long

typedef long long ll;

#define range(i, n) for (int i = 0; i < (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)

#define all(a) (a).begin(), (a).end()

struct Par {
    int32_t a, b, c;

    Par(int32_t a_, int32_t b_, int32_t c_) {
        a = a_;
        b = b_;
        c = c_;
    }

    long double eval(long double x) {
        return a * x * x + b * x + c;
    }
};

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    int32_t n;
    std::cin >> n;

    std::vector<Par> pos, neg;
    for(int32_t i = 0; i < n; i++)  {
        int32_t a, b, c;
        std::cin >> a >> b >> c;

        if(a > 0)
            pos.emplace_back(a, b, c);
        else
            neg.emplace_back(a, b, c);
    }

    if(pos.size() == 0) {
        std::cout << 0 << " " << -2'000'000'000;
        return 0;
    }
    if(neg.size() == 0) {
        std::cout << 0 << " " << 2'000'000'000;
        return 0;
    }

    long double l = -2e18, r = 2e18;
    for(int32_t z = 0; z < 100; z++) {
        long double m1 = l + (r - l) / 3;
        long  double m2 = r - (r - l) / 3;

        long double max_pos = -DBL_MAX;
        for(int32_t i = 0; i < pos.size(); i++)
            max_pos = std::max(max_pos, pos[i].eval(m1));
        long double min_neg = DBL_MAX;
        for(int32_t i = 0; i < neg.size(); i++)
            min_neg = std::min(min_neg, neg[i].eval(m1));

        long double max_pos2 = -DBL_MAX;
        for(int32_t i = 0; i < pos.size(); i++)
            max_pos2 = std::max(max_pos2, pos[i].eval(m2));
        long double min_neg2 = DBL_MAX;
        for(int32_t i = 0; i < neg.size(); i++)
            min_neg2 = std::min(min_neg2, neg[i].eval(m2));

        long double diff1 = max_pos - min_neg;
        long double diff2 = max_pos2 - min_neg2;

        if(diff1 > diff2)
            l = m1;
        else
            r = m2;
    }

    long double max_pos = -DBL_MAX;
    for(int32_t i = 0; i < pos.size(); i++)
        max_pos = std::max(max_pos, pos[i].eval(l));
    long double min_neg = DBL_MAX;
    for(int32_t i = 0; i < neg.size(); i++)
        min_neg = std::min(min_neg, neg[i].eval(l));

    std::cout << std::setprecision(20) << std::fixed;
    std::cout << l << " " << (max_pos + min_neg) / 2;
    return 0;
}
