//
// Created by olymp on 12.12.2021.
//

#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <string>
#include <numeric>
#include <cmath>
#include <bitset>
#include <set>
#include <iomanip>
#include <cassert>

using namespace  std;
#define int long long

typedef long long ll;

#define range(i, n) for (int i = 0; i < (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)

#define all(a) (a).begin(), (a).end()

#define BASE 97
#define MOD 998244353

int32_t* mask;
int32_t** hashes;
bool solve(std::vector<int32_t>& ind, int32_t taken) {
    if(ind.size() == 1)
        return true;

    int32_t mask_all = INT32_MAX;
    for(int32_t i = 0; i < ind.size(); i++)
        mask_all &= mask[ind[i]];

    int32_t char_ = -1;
    for(int32_t i = 0; i < 26; i++)
        if(mask_all & (1 << i))
            if((taken & (1 << i)) == 0)
                char_ = i;

    if(char_ == -1)
        return false;

    std::map<int32_t, std::vector<int32_t> > children;
    for(int32_t i = 0; i < ind.size(); i++) {
        int32_t hash = hashes[ind[i]][char_];
        children[hash].push_back(ind[i]);
    }

    for(auto it = children.begin(); it != children.end(); it++)
        if(!solve(it->second, taken | (1 << char_)))
            return false;
    return true;
}

signed main() {
    int32_t len, n;
    std::cin >> len >> n;

    std::string* str = new std::string[n];
    for(int32_t i = 0; i < n; i++)
        std::cin >> str[i];

    hashes = new int32_t*[n];
    for(int32_t i = 0; i < n; i++) {
        hashes[i] = new int32_t[26];
        for(int32_t j = 0; j < 26; j++) {
            hashes[i][j] = 0;
            for(int32_t k = 0; k < len; k++)
                hashes[i][j] = ((int64_t)hashes[i][j] * BASE + (str[i][k] == 'a' + j ? 2 : 1)) % MOD;
        }
    }

    mask = new int32_t[n];
    for(int32_t i = 0; i < n; i++) {
        mask[i] = 0;
        for(int32_t j = 0; j < len; j++)
            mask[i] |= 1 << (str[i][j] - 'a');
    }

    std::vector<int32_t> ind;
    for(int32_t i = 0; i < n; i++)
        ind.push_back(i);
    std::cout << (solve(ind, 0) ? "YES" : "NO");
    return 0;
}

