#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <complex>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <ctime>

using namespace std;

#define en '\n'
#define endl '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef long long ll;
//typedef __int128_t int128;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef complex<long double> comp;

const int INF = 1e9 + 7;
const ll INFLL = 1e18;
const long double EPS = 1e-9;
const long double PI = acos(-1);

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

ld START_TIME, TIME;

bool ok(vector<ll> &a, vector<ll> &b, int m) {
    int n = sz(a) - 1;
    int i = 0, j = 0;
    for (; i < n;) {
        if (abs(i - j) > m) {
            return 0;
        }
        int d = min(a[i], b[j]);
        a[i] -= d;
        b[j] -= d;
        if (a[i] == 0) {
            ++i;
        }
        if (b[j] == 0) {
            ++j;
        }
    }
    if (i != n && j == n) {
        return 0;
    }
    return 1;
}

void solve() {
    int n;
    cin >> n;
    vector<ll> a(n + 1, 0), b(n + 1, 0);
    ll sa = 0, sb = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        sa += a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        sb += b[i];
    }
    if (sa > sb) {
        cout << -1 << en;
        return;
    }
    int l = -1, r = n;
    while (r - l > 1) {
        int m = l + (r - l) / 2;
        if (ok(a, b, m)) {
            r = m;
        }
        else {
            l = m;
        }
    }
    cout << r << en;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    START_TIME = clock();
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    solve();
#ifdef LOCAL
    TIME = (clock() - START_TIME) / CLOCKS_PER_SEC;
    cerr << endl << TIME * 1000 << " ms." << endl;
#endif
    return 0;
}