#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <complex>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <ctime>

using namespace std;

#define en '\n'
#define endl '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef long long ll;
//typedef __int128_t int128;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef complex<long double> comp;

//const int INF = 1e9 + 7;
const ll INFLL = 1e18;
const long double EPS = 1e-8;
const long double PI = acos(-1);

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

ld START_TIME, TIME;

const ld INF = 1e10;

struct parab {
    ld a, b, c;
    parab() {}
    parab(ld a, ld b, ld c) : a(a), b(b), c(c) {}

    ld vert_x() {
        return -b / (2 * a);
    }

    ld vert_y() {
        return get(vert_x());
    }

    ld D() {
        return b * b - 4 * a * c;
    }

    ld get(ld x) {
        return a * x * x + b * x + c;
    }
};

ld inter1(parab a) {
    ld x = (-a.b) / (2 * a.a);
    return x;
}

pair<ld, ld> inter2(parab a) {
    ld x1 = (-a.b + sqrt(a.D())) / (2 * a.a);
    ld x2 = (-a.b - sqrt(a.D())) / (2 * a.a);
    if (x1 > x2) {
        swap(x1, x2);
    }
    return {x1, x2};
}

void solve() {
    int n;
    cin >> n;
    vector<parab> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].a >> a[i].b >> a[i].c;
    }
    ld l = INF, r = -INF;
    for (int i = 0; i < n; ++i) {
        l = min(l, a[i].vert_x());
        r = max(r, a[i].vert_x());
    }
    l -= 1000;
    r += 2000;
    for (int _ = 0; _ < 50; ++_) {
        ld l1, l2;
        ld m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
        {
            ld mn_y = -1e35, mx_y = 1e35;
            for (int i = 0; i < n; ++i) {
                if (a[i].a < 0) {
                    mx_y = min(mx_y, a[i].get(m1));
                }
                else {
                    mn_y = max(mn_y, a[i].get(m1));
                }
            }
            l1 = mx_y - mn_y;
        }
        {
            ld mn_y = -1e35, mx_y = 1e35;
            for (int i = 0; i < n; ++i) {
                if (a[i].a < 0) {
                    mx_y = min(mx_y, a[i].get(m2));
                }
                else {
                    mn_y = max(mn_y, a[i].get(m2));
                }
            }
            l2 = mx_y - mn_y;
        }
        if (l1 > l2) {
            r = m2;
        }
        else {
            l = m1;
        }
    }
    ld X = l + (r - l) / 2;
    ld mn_y = -1e35, mx_y = 1e35;
    for (int i = 0; i < n; ++i) {
        if (a[i].a < 0) {
            mx_y = min(mx_y, a[i].get(X));
        }
        else {
            mn_y = max(mn_y, a[i].get(X));
        }
    }
    cout << X << ' ' << (mn_y + (mx_y - mn_y) / 2);
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    START_TIME = clock();
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    cout << fixed << setprecision(10);
    cerr << fixed << setprecision(10);
    solve();
#ifdef LOCAL
    TIME = (clock() - START_TIME) / CLOCKS_PER_SEC;
    cerr << endl << TIME * 1000 << " ms." << endl;
#endif
    return 0;
}