#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <unordered_set>
#include <cmath>
#include <random>
#include <bitset>
#include <algorithm>

#define int long long
#define double long double


using namespace std;

const int N = 2e5 + 5;
const double eps = 1e-12;

double a[N], pref_max[N], pref_min[N], suff_max[N], suff_min[N];
double res[N];

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> a[i];
    pref_min[0] = suff_min[n + 1] = 2e9;
    for (int i = 1; i <= n; i++) {
        pref_max[i] = max(pref_max[i - 1], a[i]);
        pref_min[i] = min(pref_min[i - 1], a[i]);
    }
    for (int i = n; i; i--) {
        suff_max[i] = max(suff_max[i + 1], a[i]);
        suff_min[i] = min(suff_min[i + 1], a[i]);
    }
    cout << 1 << " ";
    for (int i = 2; i <= n; i++) {
        double lmin = pref_min[i - 1];
        double lmax = pref_max[i - 1];
        double rmin = suff_min[i];
        double rmax = suff_max[i];
        if (rmax > lmax) {
            double d = lmax / rmax;
            rmin *= d;
            if (rmin > lmin)
                d *= lmin / rmin;
            cout << 1 - d;
        } else if (rmin > lmin) {
            cout << 1 - lmin / rmin << " ";
        } else {
            cout << 0 << " ";
        }
    }
    cout << '\n';
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    cout.setf(ios::fixed);
    cout.precision(20);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.setf(ios::fixed);
    cout.precision(10);
#endif

    solve();
}