#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")
#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>
#include <iomanip>
#include <string>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;

ld EPS = 1e-18;

struct P {
	ld a, b, c;
	
	P() = default;
	P(ld a, ld b, ld  c) : a(a), b(b), c(c) {}

	P operator -(P& p) {
		P ans;
		ans.a = a - p.a;
		ans.b = b - p.b;
		ans.c = c - p.c;
		return ans;
	}

};

ld res(P& p, ld x) {
	return (ld)p.a * x * x + (ld)p.b * x + p.c;
}

bool operator < (P& a, ld y) {
	return res(a, -(double)a.b / 2 / a.a) < y - EPS;
}

pair<ld, ld> rt(P& p, ld y) {
	if ((p.a > 0 && !(p < y)) || (p.a < 0 && (p < y))) return {(ld)0, (ld)-1};
	p.c -= y;
	ld x1 = -p.b / 2 / p.a + sqrt(p.b * p.b - p.a * p.c * 4) / 2 / p.a;
	ld x2 = -p.b / 2 / p.a - sqrt(p.b * p.b - p.a * p.c * 4) / 2 / p.a;
	p.c += y;
	return { min(x2, x1), max(x1, x2) };
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	int n;
	cin >> n;
	vector<P>a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i].a >> a[i].b >> a[i].c;
	}
	ld l = -1e18;
	ld r = 1e18;
	for (int _ = 0; _ < 100; _++) {
		ld y = (l + r) / 2;
		bool f = 1;
		for (int i = 0; i < n; ++i) {
			if (a[i].a > 0 && !(a[i] < y)) {
				l = y;
				f = 0;
				break;
			}
			if (a[i].a < 0 && (a[i] < y)) {
				r = y;
				f = 0;
				break;
			}
		}
		if (!f) continue;
		int ind1 = 0;
		int ind2 = 0;
		ld l1 = -1e18;
		ld r1 = 1e18;
		vector<pair<ld, ld>>c(n);
		for (int i = 0; i < n; ++i) {
			c[i] = rt(a[i], y);
			if (c[i].first > l1) {
				l1 = c[i].first;
				ind1 = i;
			}
			if (c[i].second < r1) {
				r1 = c[i].second;
				ind2 = i;
			}
		}
		if (l1 < r1 - EPS) {
			l = y;
			r = y;
			break;
		}
		if (a[ind1].a > 0 && a[ind2].a > 0) {
			l = y;
		}
		else if (a[ind1].a < 0 && a[ind2].a < 0) {
			r = y;
		}
		else {
			P p1 = a[ind2] - a[ind1];
			pair<ld, ld>x = rt(p1, 0);
			if (res(a[ind1], x.first) < y || res(a[ind1], x.second) < y) {
				r = y;
			}
			else l = y;
		}
	}
	ld l1 = -1e18;
	ld r1 = 1e18;
	vector<pair<ld, ld>>c(n);
	for (int i = 0; i < n; ++i) {
		c[i] = rt(a[i], l);
		if (c[i].first > l1) {
			l1 = c[i].first;
		}
		if (c[i].second < r1) {
			r1 = c[i].second;
		}
	}
	cout << (l1 + r1) / 2 << ' ' << l;
	return 0;
}