#include<iostream>
#include<vector>
#include<algorithm>
#include <iomanip>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cmath>

#define _CRT_SECURE_NO_WARNINGS

using namespace std;

#define ld long double

struct Point {
	ld x, y;

	Point() {}

	Point(ld _x, ld _y) {
		x = _x;
		y = _y;
	}
};

struct Par {
	ld a, b, c;

	Par() {}

	Par(ld _a, ld _b, ld _c) {
		a = _a;
		b = _b;
		c = _c;
	}
};

istream& operator>> (istream& in, Point& p) {
	return in >> p.x >> p.y;
}

istream& operator>> (istream& in, Par& p) {
	return in >> p.a >> p.b >> p.c;
}

pair<ld, ld> solve(ld a, ld b, ld c) {
	ld D = b * b - 4 * a * c;
	ld first = (-b + sqrt(D)) / 2.0;
	ld second = (-b - sqrt(D)) / 2.0;
	return { second, first };
}

pair<Point, Point> intersect(Par p, Point A, Point B) {
	ld k = (B.x - A.x) / (B.y - A.y);
	ld b = B.y - k * B.x;
	auto s = solve(p.a, p.b - k, p.c - b);
	ld x1 = s.first;
	ld x2 = s.second;
	Point first = A;
	Point second = B;
	if (A.x < x1 && x1 < B.x) {
		first = Point(x1, k * x1 + b);
	}
	if (A.x < x2 && x2 < B.x) {
		second = Point(x2, k * x2 + b);
	}
	return { first, second };
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);
	cout << fixed << setprecision(15);
	int n;
	cin >> n;
	vector<Par> pars(n);
	Par neg;
	bool found1 = false;
	int idx1 = 0;
	int idx2 = 0;
	bool found2 = false;
	Par pos;
	for (int i = 0; i < n; i++) {
		cin >> pars[i];
		if ((pars[i].a < 0) && (!found1)) {
			neg = pars[i];
			idx1 = i;
			found1 = true;
		}
		if ((pars[i].a > 0) && (!found2)) {
			pos = pars[i];
			idx2 = i;
			found2 = true;
		}
	}
	if (!found1) {
		cout << 0 << ' ' << 1e18 << '\n';
		return 0;
	}
	if (!found2) {
		cout << 0 << ' ' << -1e18 << '\n';
		return 0;
	}
	auto sls = solve(neg.a - pos.a, neg.b - pos.b, neg.c - pos.c);
	ld y1 = neg.a * sls.first * sls.first + neg.b * sls.first + neg.c;
	ld y2 = neg.a * sls.second * sls.second + neg.b * sls.second + neg.c;
	Point L(sls.first, y1);
	Point R(sls.second, y2);
	for (int i = 0; i < n; i++) {
		if (i == idx1 || i == idx2)
			continue;
		auto p = intersect(pars[i], L, R);
		L = p.first;
		R = p.second;
	}
	cout << (L.x + R.x) / 2.0 << ' ' << (L.y + R.y) / 2.0;
	return 0;
}