#include<iostream>
#include<vector>
#include<algorithm>
#include <iomanip>
#include <string>
#include <map>
#include <set>

#define _CRT_SECURE_NO_WARNINGS

using namespace std;

#define int long long
const int MOD = 998244353;

vector<string> words;

bool solve(vector<string>& words, set<char> used = {}) {
	if (words.size() == 1)
		return true;
	map<char, set<string>> letters;
	for (auto s : words) {
		for (char t : s) {
			letters[t].insert(s);
		}
	}
	bool ok = false;
	vector<char> nice;
	for (auto p : letters) {
		if (p.second.size() == words.size() && !used.count(p.first)) {
			nice.push_back(p.first);
			ok = true;
		}
	}
	if (!ok)
		return false;

	char letter = nice[0];
	map<string, vector<int>> idx;
	for (string word : words) {
		vector<int> id;
		for (int i = 0; i < word.size(); i++)
			if (word[i] == letter)
				id.push_back(i);
		idx[word] = id;
	}

	map<vector<int>, vector<string>> q;
	for (auto p : idx) {
		q[p.second].push_back(p.first);
	}

	bool flag = true;
	auto now = used;
	now.insert(letter);
	for (auto p : q) {
		if (p.second.size() > 1) {
			flag &= solve(p.second, now);
		}
	}
	return flag;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);
	int l, n;
	cin >> l >> n;
	words.resize(n);
	for (int i = 0; i < n; i++)
		cin >> words[i];
	cout << (solve(words) ? "YES" : "NO");
	return 0;
}