#include <algorithm>
#include <array>
#include <bitset>
#include <cassert>
#include <ccomplex>
#include <climits>
#include <cmath>
#include <deque>
#include <fstream>
#include <iostream>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <limits>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<long long, long long> Pair;

const long long MOD = 1e9 + 7;
const long long INF = LLONG_MAX;

#define endl "\n"
#define debug cout << "# sus" << endl;

//#define FILE

bool check(int m, vector<int>  &a, vector<int> &b){
    int n = a.size();
    vector<int> v = a;
    for (int i = 0; i < n; ++i) {
        if (v[i] > b[i]) {
            int j = max(0, i - m);
            while (j <= min(n - 1, i + m) && v[i] > b[i]){
                if (v[j] < b[j]){
                    v[i] -= min(v[i] - b[i], b[j] - v[j]);
                    v[j] += min(v[i] - b[i], b[j] - v[j]);
                }
                ++j;
            }
            if (v[i] > b[i]) return false;
        }
    }
    return true;
}

void solve() {
    int n; cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i){
        cin >> a[i];
    }
    vector<int> b(n);
    for (int i = 0; i < n; ++i){
        cin >> b[i];
    }
    int l = -1;
    int r = n;

    while (r - l > 1){
        int m = (r +  l)/2;

        if (check(m, a, b)) r =  m;
        else l = m;
    }
    if (r == n){cout << -1; return;}
    cout << r;
}

signed main() {
#ifdef FILE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    long long tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
