#include <algorithm>
#include <array>
#include <bitset>
#include <cassert>
#include <ccomplex>
#include <climits>
#include <cmath>
#include <deque>
#include <fstream>
#include <iostream>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <limits>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<long long, long long> Pair;

const long long MOD = 1e9 + 7;
const long long INF = LLONG_MAX;

#define endl "\n"
#define debug cout << "# sus" << endl;

//#define FILE

bool check(long long m, vector<long long> &a, vector<long long> &b) {
    long long n = a.size();
    vector<long long> v = a;
    for (long long i = 0; i < n; ++i) {
        for (ll j = max(0LL, i - m); j <= min(n - 1, i + m) && v[i] > b[i]; j++) {
            if (j == i) continue;
            ll x = min(v[i], b[j] - v[j]);
            v[i] -= x;
            v[j] += x;
        }
        if (v[i] > b[i]) return false;
    }
    return true;
}

void solve() {
    long long n;
    cin >> n;
    vector<long long> a(n);
    for (long long i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<long long> b(n);
    for (long long i = 0; i < n; ++i) {
        cin >> b[i];
    }
    long long l = -1;
    long long r = n + 1;

    while (r - l > 1) {
        long long m = (r + l) / 2;

        if (check(m, a, b)) r = m;
        else l = m;
    }
    if (check(r, a, b)) cout << r;
    else if (l != -1 && check(l, a, b)) cout << l;
    else cout << -1;
}

signed main() {
#ifdef FILE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    long long tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
