#include <algorithm>
#include <array>
#include <bitset>
#include <cassert>
#include <ccomplex>
#include <climits>
#include <cmath>
#include <deque>
#include <fstream>
#include <iostream>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <limits>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> Pair;

const long long MOD = 1e9 + 7;
const long long INF = LLONG_MAX;
const long double EPS = 1e-9;

#define endl "\n"
#define debug cout << "# sus" << endl;

//#define FILE

void solve() {
    int n;
    cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];

    vector <Pair> left(n);
    left[0] = {0, 0};
    int mx = a[0], mn = a[0];
    for (int i = 1; i < n; ++i) {
        left[i] = {mn, mx};
        mn = min(mn, a[i]);
        mx = max(mx, a[i]);
    }

    vector <Pair> right(n);
    right[n - 1] = {a[n - 1], a[n - 1]};
    mx = a[n - 1], mn = a[n - 1];
    for (int i = n - 2; i >= 0; --i) {
        mn = min(mn, a[i]);
        mx = max(mx, a[i]);
        right[i] = {mn, mx};
    }

    vector<double> result(n);
    for (int i = 0; i < n; ++i) {
        int lmn = left[i].first;
        int lmx = left[i].second;
        int rmn = right[i].first;
        int rmx = right[i].second;

        double l = 0.0, r = 1.0;
        while (r - l > EPS) {
            double current = (r + l) / 2;
            double cmn = rmn * (1 - current);
            double cmx = rmx * (1 - current);
            if (cmx <= lmx && cmx >= lmn && cmn <= lmx && cmn >= lmn) {
                l = current;
                continue;
            }
            if (cmx > lmx) {
                l = current;
            } else {
                r = current;
            }
        }

        result[i] = r;
    }

    cout.precision(16);
    for (int i = 0; i < n; ++i) {
        cout << fixed << result[i] << " ";
    }
    cout << "\n";
}

signed main() {
#ifdef FILE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    long long tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
