#include <algorithm>
#include <array>
#include <bitset>
#include <cassert>
#include <ccomplex>
#include <climits>
#include <cmath>
#include <deque>
#include <fstream>
#include <iostream>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <limits>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<long long, long long> Pair;

const long long MOD = 1e9 + 7;
const long long INF = LLONG_MAX;

#define endl "\n"
#define debug cout << "# sus" << endl;

//#define FILE

ll l, n;

vector<set<char>> cur;
vector<string> q;

set<char> pipao(set<char> &a, set<char> &b) {
    set<char> ans;
    for (char x: a) {
        if (b.find(x) != b.end()) ans.insert(x);
    }
    return ans;
}

bool gen(vector<ll> &key, vector<ll> &ind) {
    if (ind.size() == 1) return true;
    bool flag = true;
    set<char> cur_set = cur[ind[0]];
    for (ll i = 1; i < ind.size(); i++) {
        cur_set = pipao(cur_set, cur[ind[i]]);
    }
    if (cur_set.empty()) {
        return false;
    }
    bool ans = true;
    map<vector<ll>, vector<ll>> new_aboba;
    for (ll j: ind) {
        vector<ll> pos;
        for (char x: cur_set) {
            for (ll i = 0; i < l; i++) {
                if (q[j][i] == x) {
                    pos.push_back(i);
                    q[j][i] = '.';
                    cur[j].erase(x);
                }
            }
        }
        new_aboba[pos].push_back(j);
    }
    for (pair<vector<ll>, vector<ll>> lol: new_aboba) {
        ans &= gen(lol.first, lol.second);
    }
    return ans;
}

void solve() {
    cin >> l >> n;
    vector<vector<ll>> cnt(n, vector<ll>(26, 0));
    cur.resize(n);
    for (ll i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (char x: s) {
            cnt[i][x - 'a']++;
            cur[i].insert(x);
        }
        q.push_back(s);
    }
    vector<char> all;
    for (ll i = 0; i < 26; i++) {
        bool flag = true;
        for (ll j = 0; j < n; j++) {
            flag &= (cnt[j][i] != 0);
        }
        if (flag) {
            all.push_back(char('a' + i));
        }
    }
    map<vector<ll>, vector<ll>> aboba;
    ll ind = 0;
    for (string &z: q) {
        vector<ll> pos;
        for (char x: all) {
            for (ll i = 0; i < l; i++) {
                if (z[i] == x) {
                    pos.push_back(i);
                    z[i] = '.';
                    cur[ind].erase(x);
                }
            }
        }
        aboba[pos].push_back(ind);
        ind++;
    }
    bool ans = true;
    for (pair <vector <ll>, vector <ll>> lol: aboba) {
        ans &= gen(lol.first, lol.second);
    }
    if (ans) cout << "YES\n";
    else cout << "NO\n";
}

signed main() {
#ifdef FILE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    long long tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
