#include<bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pii pair<int, int>
#define ll long long
#define pb emplace_back

const int mod = 1e9 + 7;
const ll INF = 1e9 + 1;
const int MAXN = 1e6 + 5;
int p = 179;
vector<int> my_pow;

vector<int> t;
vector<int> tmod;
vector<vector<int>> H;

void build(int v, int vl, int vr, string &s) {
    if (vr - vl == 1) {
        t[v] = s[vl];
        return;
    }
    int vm = (vl + vr) / 2;
    build(2 * v + 1, vl, vm, s);
    build(2 * v + 2, vm, vr, s);
    t[v] = (t[2 * v + 2] + t[2 * v + 1] * (ll)my_pow[vr - vm]) % mod;
}

void push(int v, int vl, int vr) {
    if (tmod[v] == -1) return;
    int vm = (vl + vr) / 2;
    t[2 * v + 1] = H[tmod[v] - 'a'][vm - vl];
    t[2 * v + 2] = H[tmod[v] - 'a'][vr - vm];
    tmod[2 * v + 1] = tmod[2 * v + 2] = tmod[v];
    tmod[v] = -1;
}

void modi(int v, int vl, int vr, int l, char c) {
    if (l >= vr) return;
    if (vr - vl == 1) {
        t[v] = c;
        return;
    }
    push(v, vl, vr);
    int vm = (vl + vr) / 2;
    if (l >= vm) modi(2 * v + 2, vm, vr, l, c);
    else {
        tmod[2 * v + 2] = c;
        t[2 * v + 2] = H[c - 'a'][vr - vm];
        modi(2 * v + 1, vl, vm, l, c);
    }
    t[v] = (t[2 * v + 2] + t[2 * v + 1] * (ll)my_pow[vr - vm]) % mod;
}

vector<string> a;
vector<vector<int>> h;
string s;

int get_pr(int v, int vl, int vr, int i, int pr_hash = 0) {
    //cout << vl << " " << vr << endl;
    if (vr - vl == 1) {
        return h[i][vr] == (pr_hash * (ll)p + t[v]) % mod;
    }
    push(v, vl, vr);
    int vm = (vl + vr) / 2;
    if ((int)a[i].size() < vm) return get_pr(2 * v + 1, vl, vm, i, pr_hash);
    if (h[i][vm] != (pr_hash * (ll)my_pow[vm - vl] + t[2 * v + 1]) % mod) return get_pr(2 * v + 1, vl, vm, i, pr_hash);
    if ((int)a[i].size() == vm) return vm - vl;
    return vm - vl + get_pr(2 * v + 2, vm, vr, i, (pr_hash * (ll)my_pow[vm - vl] + t[2 * v + 1]) % mod);
}

int get_id(int v, int vl, int vr, int id) {
    if (vr - vl == 1) return t[v];
    push(v, vl, vr);
    int vm = (vl + vr) / 2;
    if (id < vm) return get_id(2 * v + 1, vl, vm, id);
    else return get_id(2 * v + 2, vm, vr, id);
}

int solve() {
    int n = a.size();
    int left = -1, right = n;
    while (right - left > 1) {
        int mid = (left + right) / 2;
        if (a[mid].empty()) {
            left = mid;
            continue;
        }
        int len = get_pr(0, 0, s.size(), mid);
        if (len == (int)s.size()) {
            right = mid;
            continue;
        }
        if (len == (int)a[mid].size()) {
            left = mid;
            continue;
        }
        if (a[mid][len] < get_id(0, 0, s.size(), len)) left = mid;
        else right = mid;
    }
    return right;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    my_pow.resize(MAXN);
    my_pow[0] = 1;
    for (int i = 1; i < MAXN; i++) {
        my_pow[i] = (my_pow[i - 1] * (ll)p) % mod;
    }
    H.assign(26, vector<int>(MAXN));
    for (int i = 0; i < 26; i++) {
        for (int j = 1; j < MAXN; j++) H[i][j] = (H[i][j - 1] * (ll)p + i + 'a') % mod;
    }
    int n, q;
    cin >> n >> q;
    cin >> s;
    t.resize(4 * (int)s.size());
    tmod.resize(4 * (int)s.size(), -1);
    build(0, 0, s.size(), s);
    a.resize(n);
    for (auto &c : a) cin >> c;
    sort(all(a));
    h.resize(n);
    for (int i = 0; i < n; i++) {
        h[i].resize(a[i].size() + 1);
        for (int j = 0; j < (int)a[i].size(); j++) h[i][j + 1] = (h[i][j] * (ll)p + a[i][j]) % mod;
    }
    cout << solve() << "\n";
    while (q--) {
        int k;
        char c;
        cin >> k >> c; k--;
        modi(0, 0, s.size(), k, c);
        cout << solve() << "\n";
    }
    return 0;
}
