#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <unordered_set>
#include <unordered_map>


//#pragma GCC target("avx")
//#pragma GCC optimize(3)
//#pragma GCC optimize("inline-functions")



#define ll long long
#define ld long double
#define pr pair<ll, ll>
#define vl vector<ll>
#define all(a) (a.begin(), a.end())

using namespace std;

unordered_set<char> letters_of(const string& word) {
	unordered_set<char> res;

	for (auto ch : word) 
		res.insert(ch);

	return res;
}

struct Word {
	const string word;
	string tmp;
	unordered_set<char> letters;

	Word(string&& wrd) : word(wrd) {
		tmp = string(word.size(), '?');
		letters = letters_of(word);
	}
};

unordered_set<char> interception(const vector<Word*>& words) {
	if (words.empty()) return {};
	unordered_set<char> res = words[0]->letters;
	unordered_set<char> tmp;

	for (const auto word : words) {
		for (char ch : word->letters) {
			if (res.count(ch) != 0) tmp.insert(ch);
		}
		swap(res, tmp);
		tmp.clear();
	}

	return move(res);
}

bool recursion(const vector<Word*>& words, int old_interception_size) {
	auto inter = interception(words);

	if (inter.size() == old_interception_size) return words.size() == 1;

	unordered_map<string, vector<Word*>> rec;

	for (auto word : words) {
		for (int i = 0; i < word->word.size(); ++i) {
			if (inter.count(word->word[i]) != 0) word->tmp[i] = word->word[i];
		}

		rec[word->tmp].push_back(word);
	}

	for (const auto& par : rec) {
		if (!recursion(par.second, inter.size())) return false;
	}

	return true;
}

void solve() {
	int l, n;
	cin >> l >> n;

	vector<Word*> vec(n);

	for (auto& e : vec) {
		string word;
		cin >> word;
		e = new Word(move(word));
	}

	cout << ((recursion(vec, 0)) ? "YES" : "NO") << endl;
}



int main() {
	ios::sync_with_stdio(false);
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	ll t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}